C***********************************************************************34400005
C                                                                       34400006
C                           CDM2 (DATED 89142)                          34400010
C                                                                       34400011
C               *** SEE CMD2 MODEL CHANGE BULLETIN MCB#1 ***            34400012
C                                                                       34400013
C     ON THE SUPPORT CENTER FOR REGULATORY AIR MODELS BULLETIN BOARD    34400014
C                                                                       34400015
C                              919-541-5742                             34400016
C                                                                       34400017
C***********************************************************************34400018
C                    CDM - VERSION 2.0 (DATED 85293)
C
C         CDM CLIMATOLOGICAL DISPERSION MODEL VERSION 2.0 (BATCH)       34400020
C                                                                       34400030
C                                                                       34400040
C                                                                       34400050
C                                                                       34400060
C                                                                       34400070
C * * *   PROGRAM ABSTRACT                                              34400080
C                                                                       34400090
C         CDM-2.0 DETERMINES LONG-TERM (SEASONAL OR ANNUAL) QUASI-      34400100
C         STABLE POLLUTANT CONCENTRATIONS IN A RURAL OR URBAN SETTING   34400110
C         USING AVERAGE EMISSION RATES FROM POINT AND AREA SOURCES AND  34400120
C         A JOINT FREQUENCY DISTRIBUTION OF WIND DIRECTION, WIND SPEED, 34400130
C         AND STABILITY.  THE GAUSSIAN PLUME HYPOTHESIS FORMS THE BASIS 34400140
C         FOR THE CALCULATIONS.  CONTRIBUTIONS ARE CALCULATED ASSUMING  34400150
C         THE NARROW PLUME HYPOTHESIS, CALDER (1971, 1977), AND INVOLVE 34400160
C         AN UPWIND INTEGRATION OVER THE AREA SOURCES.  COMPUTATIONS    34400170
C         CAN BE MADE FOR UP TO 200 POINT SOURCES AND 2500 AREA SOURCES 34400180
C         AT AN UNLIMITED NUMBER OF RECEPTOR LOCATIONS.  THE NUMBER OF  34400190
C         POINT AND AREA SOURCES CAN BE EASILY MODIFIED WITHIN THE CODE 34400200
C         CDM-2.0 IS AN ENHANCED VERSION OF CDM INCLUDING THE FOLLOWING 34400210
C         OPTIONS:  16 OR 36 WIND DIRECTION SECOTRS, INITIAL PLUME      34400220
C         DISPERSION, BUOYANCY-INDUCED DISPERSION, STACK DOWNWASH, AND  34400230
C         GRADUAL PLUME RISE.  THE USER HAS A CHOICE OF SEVEN DISPERSIO 34400240
C         PARAMETER SCHEMES.  OPTIONAL OUTPUT INCLUDES POINT AND AREA   34400250
C         CONCENTRATION ROSES AND HISTOGRAMS OF POLLUTANT CONCENTRATION 34400260
C         BY STABILITY CLASS.                                           34400270
C                                                                       34400280
C                                                                       34400290
C * * *   REFERENCES                                                    34400300
C                                                                       34400310
C         IRWIN, J. S., T. CHICO, AND J. A. CATALANO.  1985.  CDM-2.0 - 34400320
C         CLIMATOLOGICAL DISPERSION MODEL VERSION 2.0.  EPA-___/_-__-__ 34400330
C         U. S. ENVIRONMENTAL PROTECTION AGENCY, RESEARCH TRIANGLE PARK 34400340
C         NC.  ___ PP.                                                  34400350
C                                                                       34400360
C                                                                       34400370
C * * *   STRUCTURE AND MODULE SUMMARY                                  34400380
C                                                                       34400390
C                            CDM-2.0                                    34400400
C          _____________________!______________________                 34400410
C         !            !        !                      !                34400420
C       CLINT        CALQ     AREA                   POINT              34400430
C     ____!____                 !         _____________!____________    34400440
C    !         !                !        !         !       !        !   34400450
C  DFAULT    VIRTX           SIGMAZ    VIRTX    PLRISE    STDW    SIGMA 34400460
C              !                         !                              34400470
C              !                         !                              34400480
C            SIGMAZ                    SIGMAZ                           34400490
C                                                                       34400500
C         THE SUBROUTINE ORDER IN THE LISTING IS AS FOLLOWS:  CLINT,    34400510
C         DFAULT, CALQ, AREA, POINT, PLRISE, STDW, VIRTX, SIGMAZ, AND   34400520
C         BLOCK DATA.                                                   34400530
C                                                                       34400540
C                                                                       34400550
C * * *   INPUT/OUTPUT INFORMATION                                      34400560
C                                                                       34400570
C         FORTRAN     DATA SET                    I/O UNIT              34400580
C          UNIT                                                         34400590
C           5         CONTROL INPUT (RECORD       DISK                  34400600
C                       TYPES 1-3)                                      34400610
C          IRD*       CONTROL INPUT (RECORD       DISK                  34400620
C                       TYPES 4-18)                                     34400630
C          IWR*       OUTPUT LISTING              PRINTER OR DISK       34400640
C          IPU*       CONCENTRATION DATA          DISK OR MAGNETIC TAPE 34400650
C                                                                       34400660
C         *  SEE RECORD TYPE 3 BELOW.                                   34400670
C                                                                       34400680
C                                                                       34400690
      PARAMETER (NPTS=200,NQLIM=100,NASE=50,NASN=50)                    34400700
      DIMENSION DX(4),DY(4),A(4),KPX(38),TCON(2),CCON(2),FRECPT(16)     34400710
C         THE PARAMETER STATEMENT PERMITS STORAGE ASSIGNMENT            34400720
C          ACCORDING TO THE NEEDS OF EACH PROBLEM.  IF THE USER'S       34400730
C          FORTRAN COMPILER DOES NOT SUPPORT PARAMETER, THE DESIRED     34400740
C          NUMBER OF NPTS, NQLIM, NASE, AND NASN WILL HAVE TO BE        34400750
C          HARDCODED.  THE BEST WAY TO DO THIS IS THROUGH GLOBAL        34400760
C          CHANGES WITH AN EDITOR.                                      34400770
      COMMON /C1/ K,MX,MN,F(6,6,36),UBAR(6),U(6),RI,RJ,INC(4),DELR      34400780
      COMMON /C2/ UE(6),YD,YN,TMN,DINT,YCON,TA(4),IPG,XG,YG,IRD         34400790
      COMMON /C3/ IRUN,CA(2),CB(2),TK(36),AROS(2),PROS(2),TANG          34400800
      COMMON /C4/ DECAY(2),ICA(6),ICP(6),HL(6),HX(6),GB(2),NQ,IVER,IWR  34400810
      COMMON /C5/ Q(NQLIM,4),GA(2),IAD(4,5),IAS,TDA,TDB,TDC,IPU         34400820
      COMMON /C6/ ICHK                                                  34400830
      COMMON /QCOM/ N,DR,IX,IY,TT(36,21),KTC,IXX,IYY,RAD,TD,            34400840
     *              Z(NASE,NASN,3)                                      34400850
      COMMON /ACOM/ PI,SZA(6),ABAR(2),AROSE(36,2),XS(6)                 34400860
      COMMON /PCOM/ PH(NPTS),PR(NPTS),PS(NPTS,4),PX(NPTS),PY(NPTS),     34400870
     *              WA(36),WB(36),PROSE(36,2),CV,IPS,RAT,PBAR(2),TOA,   34400880
     *              VS1(NPTS),T1(NPTS),D1(NPTS),FRN(NPTS),BFLUX(NPTS)   34400890
      COMMON /SET/ N1636,DELTA,TTAN,NP50,NPDH,NGRAD,NSTDW,KLOW,KHIGH,   34400900
     *             PPAR(2,6),APAR(2,6),WHA(6),FAC,RCEPTZ,KELVIN,NDEF    34400910
      COMMON /TITLE/ HEADNG(20),PNAME(2),D16(32),D36(72),DISP(8,7),     34400920
     *               TTITLE(3)                                          34400930
      CHARACTER*4 HEADNG,PNAME,D16,D36,DISP,TTITLE                      9240000
C                                                                       34400940
C         FORM OF INPUT TO CDM-2.0 (BATCH)                              34400950
C                                                                       34400960
C     VARIABLE                                                          34400970
C     NAME   COLMN  FRMT           DESCRIPTION                          34400980
C                                                                       34400990
C  RECORD TYPE 1 * * * RUN TITLE * * *                                  34401000
C                                                                       34401010
C     HEADNG 1-80  20A4            DESCRIPTION OR TITLE OF MODEL RUN.   34401020
C                                                                       34401030
C  RECORD TYPE 2 * * * POLLUTANTS * * *                                 34401040
C                                                                       34401050
C     NSO2    1     I1             POLLUTANT NUMBER FOR SO2             34401060
C                                    = 0, SO2 NOT CONSIDERED IN RUN     34401070
C                                    = 1, POLLUTANT 1 IS SO2            34401080
C                                    = 2, POLLUTANT 2 IS SO2            34401090
C     PNAME  5-12   2A4            NAMES OF TWO POLLUTANTS TO BE MODELE 34401100
C                                                                       34401110
C  RECORD TYPE 3 * * * PARAMETERS * * *                                 34401120
C                                                                       34401130
C     AROS   1-8   2A4  AAAA       ALPHA AREA ROSE OUTPUT ID            34401140
C     PROS   9-16  2A4  AAAA       ALPHA POINT ROSE OUTPUT ID           34401150
C     IRUN  17-21  I5   XXXXX      USER DEFINED RUN ID NUMBER           34401160
C     NLIST 22-26  I5   XXXXX      CONTROL FOR PRINTED OUTPUT           34401170
C                                  IF NLIST > 0 ECHO SETUP INFO + METEO 34401180
C                                               LIST CONC. RESULTS      34401190
C                                  IF NLIST = 0 ECHO SETUP INFO + METEO 34401200
C                                               ECHO SOURCE INFO INPUT  34401210
C                                               LIST CONC. RESULTS      34401220
C                                  IF NLIST < 0 LIST ONLY CONC. RESULTS 34401230
C     IRD   27-31  I5   XXXXX      FORTRAN LOGICAL UNIT NUMBER (READ)   34401240
C     IWR   32-36  I5   XXXXX      FORTRAN LOGICAL UNIT NUMBER (PRINTER 34401250
C     IPU   37-41  I5   XXXXX      FORTRAN LOGICAL UNIT NUMBER (PUNCH)  34401260
C     CA    42-59 2F9.0 XXXXXX.XX  INTERCEPT OF CALIBRATION             34401270
C     CB    60-77 2F9.0 XXXXXX.XX  SLOPE OF CALIBRATION                 34401280
C                                                                       34401290
C  RECORD TYPE 4 * * * PARAMETERS * * *                                 34401300
C                                                                       34401310
C     N1636  (FREE FORMAT)         NUMBER OF WIND DIRECTIONS USED IN    34401320
C                                  METEOROLOGICAL JOINT FREQUENCY       34401330
C                                  FUNCTION (EITHER 16 OR 36).          34401340
C                                                                       34401350
C     NP50   (FREE FORMAT)         INITIAL DISPERSION OPTION            34401360
C                                    < OR = 0, NO ACTION TAKEN ON POINT 34401370
C                                      SOURCES WITH RELEASE HEIGHTS     34401380
C                                      BELOW 50 M.                      34401390
C                                    > 0, INITIALLY DISPERSE AS         34401400
C                                      DESCRIBED IN CDM-2.0 USER'S GUID 34401410
C                                                                       34401420
C     NPDH   (FREE FORMAT)         BUOYANCY-INDUCED DISPERSION OPTION   34401430
C                                    < OR = 0, NO ACTION TAKEN          34401440
C                                    > 0, INCLUDE BUOYANCY INDUCED      34401450
C                                      DISPERSION EFFECTS, PASQUILL     34401460
C                                      (1976), IN POINT SOURCE DISPER-  34401470
C                                      SION AND SET PLUME AT FINAL      34401480
C                                      EFFECTIVE HEIGHT FOR ALL         34401490
C                                      DISTANCES.                       34401500
C                                                                       34401510
C     NSTDW  (FREE FORMAT)         STACK DOWNWASH OPTION                34401520
C                                    < 0, BJORKLUND AND BOWERS (1982)   34401530
C                                         STACK DOWNWASH CONSIDERED     34401540
C                                    = 0, NO ACTION TAKEN               34401550
C                                    > 0, BRIGGS (1973) STACK DOWNWASH  34401560
C                                         CONSIDERED                    34401570
C                                                                       34401580
C     NGRAD  (FREE FORMAT)         GRADUAL PLUME RISE OPTION            34401590
C                                    < OR = 0, NO ACTION TAKEN          34401600
C                                    > 0, GRADUAL PLUME RISE CONSIDERED 34401610
C                                                                       34401620
C     FAC    (FREE FORMAT)         EFFLUENT RISE FOR AREA SOURCES       34401630
C                                                                       34401640
C     RCEPTZ (FREE FORMAT)         HEIGHT (M) ABOVE GROUND OF ALL       34401650
C                                  RECEPTORS                            34401660
C                                                                       34401670
C     KELVIN (FREE FORMAT)         UNITS FLAG FOR STACK TEMPERATURE     34401680
C                                    < 0, DEGREES F                     34401690
C                                    = 0, DEGREES C                     34401700
C                                    > 0, DEGREES KELVIN                34401710
C                                                                       34401720
C     NDEF   (FREE FORMAT)         DEFAULT OPTION                       34401730
C                                   < OR = 0, NO ACTION TAKEN           34401740
C                                   > 0, IMPLEMENT DEFAULT OPTION       34401750
C                                                                       34401760
C  RECORD TYPE 5 * * * PARAMETERS * * *                                 34401770
C                                                                       34401780
C     KLOW   (FREE FORMAT)         DISPERSION PARAMETER SCHEME FOR AREA 34401790
C                                  SOURCES.  SEE COMMENTS ON KTYPE IN   34401800
C                                  SUBROUTINE SIGMAZ.  THE CDM-2.0 USER 34401810
C                                  GUIDE ALSO DESCRIBES THIS PARAMETER. 34401820
C                                                                       34401830
C     ICA    (FREE FORMAT)         ARRAY OF SIX (6) VALUES DEFINING     34401840
C                                  DISPERSION CURVES (AS DEFINED BY     34401850
C                                  KLOW) TO BE USED FOR THE SIX         34401860
C                                  STABILITY CATEGORIES SUMMARIZED IN   34401870
C                                  THE JOINT FREQUENCY FUNCTION.        34401880
C                                                                       34401890
C  RECORD TYPE 6 * * * PARAMETERS * * *                                 34401900
C                                                                       34401910
C     KHIGH  (FREE FORMAT)         DISPERSION PARAMETER SCHEME FOR POIN 34401920
C                                  SOURCES.  SEE COMMENTS ON KTYPE IN   34401930
C                                  SUBROUTINE SIGMAZ.  THE CDM-2.0 USER 34401940
C                                  GUIDE ALSO DESCRIBES THIS PARAMETER. 34401950
C                                                                       34401960
C     ICP    (FREE FORMAT)         ARRAY OF SIX (6) VALUES DEFINING     34401970
C                                  DISPERSION CURVES (AS DEFINED BY     34401980
C                                  KHIGH) TO BE USED FOR THE SIX        34401990
C                                  STABILITY CATEGORIES SUMMARIZED IN   34402000
C                                  THE JOINT FREQUENCY FUNCTION.        34402010
C                                                                       34402020
C  RECORD TYPE 7 * * * PARAMETERS * * *                                 34402030
C                                                                       34402040
C     DELR   1-6   F6.0 XXXXX.     RADIAL INCREMENT (M)                 34402050
C     RAT    7-12  F6.0 XXX.XX     LENGTH OF A BASIC EMISSION GRID      34402060
C                                  SQUARE IN USER UNITS                 34402070
C     CV    13-18  F6.0 XXXX.X     CONVERSION FACTOR,                   34402080
C                                  CV * RAT = EMISSION GRID INTERVAL (M 34402090
C     XG    19-24  F6.0 XXX.XX     X MAP COORD. OF THE SW CORNER OF THE 34402100
C                                  EMISSION GRID ARRAY                  34402110
C     YG    25-30  F6.0 XXX.XX     Y MAP COORD. OF THE SW CORNER OF THE 34402120
C                                  EMISSION GRID ARRAY                  34402130
C     TOA   31-36  F6.0 XXX.XX     MEAN ATMOSPHERIC TEMPERATURE (DEG C) 34402140
C     TXX   37-42  F6.0 XXXXX.     WIDTH OF BASIC EMISSION SQUARE (M)   34402150
C                                                                       34402160
C  RECORD TYPE 8 * * * PARAMETERS * * *                                 34402170
C                                                                       34402180
C     DINT   1-6   F6.0 XXXXX.     NUMBER OF SEGMENTS DESIRED IN DELTA  34402190
C                                  DEGREE SECTORS.  RANGES FROM 2 TO 20 34402200
C                                  INCLUSIVE.                           34402210
C     YD     7-12  F6.0 XXX.XX     RATIO OF THE DAYTIME EMISSION RATE   34402220
C                                  TO THE AVERAGE 24-HOUR EMISSION RATE 34402230
C     YN    13-18  F6.0 XXX.XX     RATIO OF THE NIGHTTIME EMISSION RATE 34402240
C                                  TO THE AVERAGE 24-HOUR EMISSION RATE 34402250
C     SZA   19-54 6F6.0 XXX.XX     INITIAL SIGMA-Z FOR AREA SOURCES (M) 34402260
C     GB    55-66 2F6.0 XXXXX.     DECAY HALF-LIFE (HR) FOR THE TWO     34402270
C                                  POLLUTANTS                           34402280
C                                                                       34402290
C  RECORD TYPE 9 * * * WIND PROFILE EXPONENTS * * *                     34402300
C                                                                       34402310
C     UE     (FREE FORMAT)         ARRAY OF SIX (6) VALUES DEFINING WIN 34402320
C                                  PROFILE EXPONENTS TO BE ASSOCIATED   34402330
C                                  WITH THE SIX STABILITY CATEGORIES    34402340
C                                  SUMMARIZED IN THE JOINT FREQUENCY    34402350
C                                  FUNCTION.                            34402360
C                                                                       34402370
C  RECORD TYPE 10 * * * WIND SPEEDS * * *                               34402380
C                                                                       34402390
C     U      (FREE FORMAT)         ARRAY OF SIX (6) VALUES DEFINING WIN 34402400
C                                  SPEEDS (M/SEC) TO BE ASSOCIATED WITH 34402410
C                                  THE SIX WIND SPEED CATEGORIES SUMMAR 34402420
C                                  IZED IN THE JOINT FREQUENCY FUNCTION 34402430
C                                  TYPICALLY THE HARMONIC AVERAGE WIND  34402440
C                                  SPEED IS USED.                       34402450
C                                                                       34402460
C  RECORD TYPE 11 * * * MIXING HEIGHTS * * *                            34402470
C                                                                       34402480
C     HL     (FREE FORMAT)         ARRAY OF SIX (6) VALUES DEFINING     34402490
C                                  MIXING HEIGHTS TO BE ASSOCIATED WITH 34402500
C                                  THE SIX STABILITY CATEGORIES SUMMAR- 34402510
C                                  IZED IN THE JOINT FREQUENCY FUNCTION 34402520
C                                                                       34402530
C  RECORD TYPE 12 * * * FORMAT STATEMENT * * *                          34402540
C                                                                       34402550
C     FMETEO 1-64  16A4            FORMAT STATEMENT, INCLUDING BEGINNIN 34402560
C                                  AND ENDING PARENTHESIS, FOR THE      34402570
C                                  METEOROLOGICAL JOINT FREQUENCY       34402580
C                                  FUNCTION.  OLD CDM FORMAT WAS,       34402590
C                                  (9X,6F9.0)                           34402600
C                                                                       34402610
C  RECORD TYPE 13 * * * JOINT FREQUENCY FUNCTION                        34402620
C                                                                       34402630
C     F      (SEE CARD TYPE 12)     F(I,J,K)     (PERCENT)              34402640
C                                                                       34402650
C  RECORD TYPE 14 * * * FORMAT STATEMENT * * *                          34402660
C                                                                       34402670
C     FSOURC 1-64  16A4            FORMAT STATEMENT, INCLUDING BEGINNIN 34402680
C                                  AND ENDING PARENTHESIS, FOR THE      34402690
C                                  SOURCE INVENTORY.  OLD CDM FORMAT WA 34402700
C                                  (F6.0,2F7.0,2F8.0,F7.0,F5.0,2F7.0,   34402710
C                                  F5.0)                                34402720
C                                                                       34402730
C  RECORD TYPE 15 *** SOURCE INVENTORY (VARIABLE NUMBER OF RECORDS) *** 34402740
C                                                                       34402750
C     X     (SEE RECORD TYPE 14)   X MAP COORD OF SOURCE (RE USER GUIDE 34402760
C     Y              "             Y MAP COORD OF SOURCE (RE USER GUIDE 34402770
C     TX             "             WIDTH OF AREA SOURCE.  ENTER ZERO OR 34402780
C                                  LEAVE BLANK FOR POINT SOURCES.       34402790
C     S1             "             EMISSION RATE OF POLLUTANT 1 (G/SEC) 34402800
C     S2             "             EMISSION RATE OF POLLUTANT 2 (G/SEC) 34402810
C     SH             "             SOURCE HEIGHT (M)                    34402820
C     D              "             STACK DIAMETER (M).  LEAVE BLANK FOR 34402830
C                                  AREA SOURCES.                        34402840
C     VS             "             EXIT VELOCITY (M/SEC).  LEAVE BLANK  34402850
C                                  FOR AREA SOURCES.                    34402860
C     T              "             STACK GAS TEMPERATURE (C).  LEAVE    34402870
C                                  BLANK FOR AREA SOURCES.              34402880
C     SA             "             PLUME RISE OPTION,                   34402890
C                                    < OR = 0, BRIGGS PLUME RISE        34402900
C                                    > 0, ENTER PRODUCT OF PLUME RISE   34402910
C                                      AND WIND SPEED (M**2/SEC)        34402920
C                                                                       34402930
C  RECORD TYPE 16 * * * BLANK SENTINEL CARD * * *                       34402940
C                                                                       34402950
C  RECORD TYPE 17 * * * FORMAT STATEMENT * * *                          34402960
C                                                                       34402970
C     FRECPT 1-64  16A4            FORMAT STATEMENT, INCLUDING BEGINNIN 34402980
C                                  AND ENDING PARENTHESIS, FOR THE      34402990
C                                  RECEPTOR CARDS.  OLD CDM FORMAT WAS, 34403000
C                                  (2F8.2,14X,I4,3X,I4,I5)              34403010
C                                                                       34403020
C  RECORD TYPE 18 *** RECEPTOR CARDS (VARIABLE NUMBER OF RECORDS) ***   34403030
C                                                                       34403040
C     RX     (SEE RECORD TYPE 17)  X MAP COORD. OF THE RECEPTOR         34403050
C     RY              "            Y MAP COORD. OF THE RECEPTOR         34403060
C     KPX9            "            OBSERVED CONC. OF POLLUTANT 1 AT THE 34403070
C                                  RECEPTOR, IF KNOWN                   34403080
C     KPX10           "            OBSERVED CONC. OF POLLUTANT 2 AT THE 34403090
C                                  RECEPTOR, IF KNOWN                   34403100
C     NROSE           "            OPTION FOR POLLUTANT CONC. ROSES     34403110
C                                     > 0, PRINT CONCENTRATION ROSES    34403120
C                                     < OR = 0, NO CONCENTRATION ROSES  34403130
C                                                                       34403140
C                                                                       34403150
      WRITE(6,1)
    1 FORMAT(21X,'CDM2              (DATED 89142)',/)
C
      CALL CLINT(ICOND)                                                 34403160
C                                                                       34403170
      IF (ICOND .EQ. 0) GO TO 20                                        34403180
         WRITE(IWR,10)                                                  34403190
   10    FORMAT('0*** EXECUTION TERMINATED.')                           34403200
         GO TO 620                                                      34403210
   20 DELO2 = DELTA/2.0                                                 34403220
C                                                                       34403230
C         READ RECORD TYPE 17.                                          34403240
C                                                                       34403250
      READ(IRD,30) FRECPT                                               34403260
   30 FORMAT(16A4)                                                      34403270
C                                                                       34403280
C         INITIALIZE CONCENTRATION ARRAYS                               34403290
C                                                                       34403300
   40 DO 60 I=1,2                                                       34403310
         DO 50 IDUM=1,6                                                 34403320
            PPAR(I,IDUM) = 0.0                                          34403330
            APAR(I,IDUM) = 0.0                                          34403340
   50    CONTINUE                                                       34403350
         ABAR(I)=0.                                                     34403360
         PBAR(I)=0.                                                     34403370
         DO 55 K=1,N1636                                                34403380
            AROSE(K,I)=0.                                               34403390
            PROSE(K,I)=0.                                               34403400
   55    CONTINUE                                                       34403410
   60 CONTINUE                                                          34403420
C                                                                       34403430
C         READ RECORD TYPE 18 (RECEPTOR INFORMATION).                   34403440
C          AT END OF FILE STOP EXECUTION.                               34403450
C                                                                       34403460
      READ(IRD,FRECPT,END=620)RX,RY,KPX(9),KPX(10),NROSE                34403470
C         RX:      X MAP COORD. OF THE RECEPTOR                         34403480
C         RY:      Y MAP COORD. OF THE RECEPTOR                         34403490
C         KPX(9):  OBSERVED CONC. OF POLLUTANT 1 AT THE RECEPTOR, IF    34403500
C                    KNOWN                                              34403510
C         KPX(10): OBSERVED CONC. OF POLLUTANT 2 AT THE RECEPTOR, IF    34403520
C                    KNOWN                                              34403530
C         NROSE:   OPTION FOR POLLUTANT CONCENTRATION ROSES             34403540
C                                                                       34403550
      ICHK = 0                                                          34403560
C                                                                       34403570
C          ICHK IS USED IN CALQ TO CONTROL THE PRINTING OF THE          34403580
C           WARNING MESSAGE ABOUT EXCEEDING 100 ARCS.  WE SET ICHK      34403590
C           TO ZERO WHENEVER WE READ IN A NEW RECEPTOR.  A              34403600
C           WARNING MESSAGE IS PRINTED ONLY WHEN NEEDED AND ONLY        34403610
C           WHEN ICHK = 0.  WHEN THE MESSAGE IS PRINTED, ICHK IS        34403620
C           SET TO THE VALUE OF 1 IN CALQ.  IN THIS MANNER, WE          34403630
C           PRINT THE WARNING ONLY ONCE PER RECEPTOR EVEN IF            34403640
C           MORE THAN 100 ARCS IS CALLED FOR IN MORE THAN ONE           34403650
C           SECTOR.                                                     34403660
C                                                                       34403670
C         CONVERT COORDINATES TO EMISSION GRID UNITS                    34403680
      RI=(RX-XG)/RAT+0.5                                                34403690
      RJ=(RY-YG)/RAT+0.5                                                34403700
      IF(NROSE.GE.1) GO TO 110                                          34403710
      IPG=IPG+1                                                         34403720
C         START NEW PAGE IF LINE COUNT GE 50                            34403730
      IF(IPG.LT.44) GO TO 110                                           34403740
      IPG=0                                                             34403750
      WRITE(IWR,70)IRUN,HEADNG                                          34403760
   70 FORMAT('1',35X,'CLIMATOLOGICAL DISPERSION MODEL - VERSION 2.0',/  34403770
     *        1X,53X,'RUN ',I5,//,                                      34403790
     *        1X,20A4,//)                                               34403800
      WRITE(IWR,80)                                                     34403810
   80 FORMAT(1X,39X,'CONCENTRATIONS (MICROGRAMS/CU. METER)',//)         34403820
      WRITE(IWR,90) PNAME(1),PNAME(2),PNAME(1),PNAME(2),PNAME(1),       34403830
     *              PNAME(2),PNAME(1),PNAME(2),PNAME(1),PNAME(2)        34403840
   90 FORMAT(1X,22X,'AREA  SOURCES      POINT  SOURCES     -----TOTAL', 34403850
     *       '-----      --CALIBRATED--      ---OBSERVED---',/          34403860
     *       1X,'X COORD   Y COORD',5X,5(A4,5X,A4,7X),/)                34403870
C                                                                       34403880
C         INITIALIZE SECTOR DIRECTION                                   34403890
C          K: PROGRESSES 1 THROUGH N1636 CONTROLLING SECTOR DIRECTION   34403900
C                                                                       34403910
  110 K=1                                                               34403920
C                                                                       34403930
C         IF THERE ARE NO AREA SOURCES TO EVALUATE GO TO 340 AND CHECK  34403940
C          FOR POINT SOURCES                                            34403950
C                                                                       34403960
      IF(IAS.LT.1) GO TO 340                                            34403970
C                                                                       34403980
C         THERE ARE AREA SOURCES TO EVALUATE.                           34403990
C          DETERMINE MAXIMUM AND MINIMUM DISTANCES FROM THE RECEPTOR    34404000
C          TO THE EMISSION GRID BOUNDARIES.                             34404010
C                                                                       34404020
      DX(1)=(IX-0.5)-RI                                                 34404030
      DX(2)=(IXX+0.5)-RI                                                34404040
      DX(3)=DX(2)                                                       34404050
      DX(4)=DX(1)                                                       34404060
      DY(1)=(IY-0.5)-RJ                                                 34404070
      DY(2)=DY(1)                                                       34404080
      DY(3)=(IYY+0.5)-RJ                                                34404090
      DY(4)=DY(3)                                                       34404100
      TX=(DX(1)*DX(1)+DY(1)*DY(1))**0.5                                 34404110
      TN=TX                                                             34404120
      TM=(DX(2)*DX(2)+DY(1)*DY(1))**0.5                                 34404130
      IF(TM.GT.TX) TX=TM                                                34404140
      IF(TM.LT.TN) TN=TM                                                34404150
      TM=(DX(2)*DX(2)+DY(3)*DY(3))**0.5                                 34404160
      IF(TM.GT.TX) TX=TM                                                34404170
      IF(TM.LT.TN) TN=TM                                                34404180
      TM=(DX(1)*DX(1)+DY(3)*DY(3))**0.5                                 34404190
      IF(TM.GT.TX) TX=TM                                                34404200
      IF(TM.LT.TN) TN=TM                                                34404210
      MX=TX/DR                                                          34404220
C                                                                       34404230
C         IF THE RECEPTOR IS OUTSIDE THE EMISSION GRID BOUNDARIES THEN  34404240
C            GO TO 120                                                  34404250
C                                                                       34404260
      IF(RI+0.5.LT.IX.OR.RI-0.5.GT.IXX) GO TO 120                       34404270
      IF(RJ+0.5.LT.IY.OR.RJ-0.5.GT.IYY) GO TO 120                       34404280
C                                                                       34404290
C         SET FLAG (IB) TO REMEMBER RECEPTOR IS WITHIN GRID BOUNDARIES  34404300
C                                                                       34404310
      IB=1                                                              34404320
      MN=1                                                              34404330
      GO TO 330                                                         34404340
C                                                                       34404350
C         SET FLAG (IB) TO REMEMBER RECEPTOR IS OUTSIDE GRID BOUNDARIES 34404360
C                                                                       34404370
  120 IB=2                                                              34404380
C                                                                       34404390
C         DETERMINE MINIMUM DISTANCE FROM RECEPTOR TO AREA SOURCES      34404400
C                                                                       34404410
      TMN=TN/DR                                                         34404420
      TXI=0.                                                            34404430
      TNI=400.                                                          34404440
      DO 240 I=1,4                                                      34404450
         IF(DX(I))130,150,190                                           34404460
  130    IF(DY(I).EQ.0.) GO TO 140                                      34404470
         TA(I)=ATAN(DY(I)/DX(I))*RAD+180.                               34404480
         GO TO 230                                                      34404490
  140    TA(I)=180.                                                     34404500
         GO TO 230                                                      34404510
  150    IF(DY(I))160,170,180                                           34404520
  160    TA(I)=270.                                                     34404530
         GO TO 230                                                      34404540
  170    TA(I)=0.                                                       34404550
         GO TO 230                                                      34404560
  180    TA(I)=90.                                                      34404570
         GO TO 230                                                      34404580
  190    IF(DY(I))200,210,220                                           34404590
  200    TA(I)=ATAN(DY(I)/DX(I))*RAD+360.                               34404600
         GO TO 230                                                      34404610
  210    TA(I)=360.                                                     34404620
         GO TO 230                                                      34404630
  220    TA(I)=ATAN(DY(I)/DX(I))*RAD                                    34404640
  230    IF(TA(I).GT.TXI) TXI=TA(I)                                     34404650
         IF(TA(I).LT.TNI) TNI=TA(I)                                     34404660
  240 CONTINUE                                                          34404670
      TDIF=TXI-TNI                                                      34404680
  250 DO 260 I=1,4                                                      34404690
  260    A(I)=TA(I)                                                     34404700
      TX=TXI                                                            34404710
      TN=TNI                                                            34404720
      IF(TDIF.GT.180.) GO TO 290                                        34404730
      TM=90.-TK(K)                                                      34404740
      IF(TM.LT.0.) TM=TM+360.                                           34404750
  270 IF(TM.GE.TN-DELO2) GO TO 280                                      34404760
      IF(TM.GE.DELO2) GO TO 340                                         34404770
      TM=TM+360.                                                        34404780
  280 IF(TM-(TX+DELO2))320,320,340                                      34404790
  290 TM=180.-TK(K)                                                     34404800
      IF(TM.LT.0.) TM=TM+360.                                           34404810
  300 TX=0.                                                             34404820
      TN=400.                                                           34404830
      DO 310 I=1,4                                                      34404840
         A(I)=A(I)+90.                                                  34404850
         IF(A(I).GE.360.) A(I)=A(I)-360.                                34404860
         IF(A(I).GT.TX) TX=A(I)                                         34404870
         IF(A(I).LT.TN) TN=A(I)                                         34404880
  310 CONTINUE                                                          34404890
      IF(TX-TN.LE.180.) GO TO 270                                       34404900
      TM=270.-TK(K)                                                     34404910
      IF(TM.LT.0.) TM=TM+360.                                           34404920
      GO TO 300                                                         34404930
  320 DIF=(TX-TN)/(2.*RAD)                                              34404940
      MN=TMN*COS(DIF)                                                   34404950
C         NEGATE POSSIBLE ERROR IN COSINE FUNCTION.                     34404960
      L=MOD(MN,INC(4))                                                  34404970
      IF(L.LE.0) L=INC(4)                                               34404980
      MN=MN-L                                                           34404990
C         MN ALWAYS EQUALS 1 IF RECEPTOR WITHIN AREA SOURCE GRID        34405000
      IF(MN.LT.1) MN=1                                                  34405010
  330 N=MN                                                              34405020
C                                                                       34405030
C         CALCULATE THE AREA SOURCE VECTOR                              34405040
C                                                                       34405050
      CALL CALQ                                                         34405060
C                                                                       34405070
C         CALCULATE SECTOR CONCENTRATION FROM THE AREA SOURCE VECTOR    34405080
C                                                                       34405090
      CALL AREA                                                         34405100
C                                                                       34405110
C         IF NO POINT SOURCES, GO TO NEXT SECTOR                        34405120
C                                                                       34405130
  340 IF(IPS.LE.0) GO TO 350                                            34405140
C                                                                       34405150
C         CALCULATE SECTOR CONCENTRATION FROM THE POINT SOURCES         34405160
C                                                                       34405170
      CALL POINT                                                        34405180
C                                                                       34405190
C         IF ALL THE SECTORS HAVE BEEN ANALYZED THEN PRINT AND STORE    34405200
C          THE RESULTS                                                  34405210
C                                                                       34405220
  350 IF(K.GE.N1636) GO TO 370                                          34405230
C                                                                       34405240
C         NEXT DIRECTION SECTOR. K LOOPS THROUGH N1636 SECTORS.         34405250
C                                                                       34405260
      K=K+1                                                             34405270
      DO 360 I=1,2                                                      34405280
         AROSE(K,I)=0.                                                  34405290
         PROSE(K,I)=0.                                                  34405300
  360 CONTINUE                                                          34405310
C                                                                       34405320
C         IF NO AREA SOURCES, CHECK POINT SOURCES                       34405330
C                                                                       34405340
      IF(IAS.LT.1) GO TO 340                                            34405350
C                                                                       34405360
C         BRANCH TO 330 OR 250 DEPENDS ON WHETHER RECEPTOR INSIDE (IB=1 34405370
C          OR OUTSIDE (IB=2) AREA SOURCE                                34405380
C                                                                       34405390
      GO TO (330,250),IB                                                34405400
C                                                                       34405410
C         PRINT AND STORE RESULTS                                       34405420
C                                                                       34405430
  370 DO 380 I=1,2                                                      34405440
         TCON(I)=PBAR(I)+ABAR(I)                                        34405450
         CCON(I)=CA(I)+CB(I)*TCON(I)                                    34405460
  380 CONTINUE                                                          34405470
C         TCON: TOTAL CONCENTRATION                                     34405480
C         CCON: CALIBRATED CONCENTRATION                                34405490
      IF(NROSE .LT. 1) GO TO 390                                        34405500
      WRITE(IWR,70)IRUN,HEADNG                                          34405510
      WRITE(IWR,80)                                                     34405520
      WRITE(IWR,90) PNAME(1),PNAME(2),PNAME(1),PNAME(2),PNAME(1),       34405530
     *              PNAME(2),PNAME(1),PNAME(2),PNAME(1),PNAME(2)        34405540
  390 WRITE(IWR,400)RX,RY,ABAR,PBAR,TCON,CCON,KPX(9),KPX(10)            34405550
  400 FORMAT(1X,2(F7.2,3X),4(F6.1,3X,F6.1,5X),2X,2(I4,5X))              34405560
C         ABAR: CONTRIBUTION FROM AREA SOURCES                          34405570
C         PBAR: CONTRIBUTION FROM POINT SOURCES                         34405580
C         KPX:  CARD OUTPUT VECTOR                                      34405590
      KPX(1)=ABAR(1)+0.5                                                34405600
      KPX(2)=ABAR(2)+0.5                                                34405610
      KPX(3)=PBAR(1)+0.5                                                34405620
      KPX(4)=PBAR(2)+0.5                                                34405630
      KPX(5)=TCON(1)+0.5                                                34405640
      KPX(6)=TCON(2)+0.5                                                34405650
      KPX(7)=CCON(1)+0.5                                                34405660
      KPX(8)=CCON(2)+0.5                                                34405670
      WRITE(IPU,410)RX,RY,IRUN,(KPX(L),L=1,10)                          34405680
  410 FORMAT(1X,2F10.2,I5,'I',10I4)                                     34405690
      IF(NROSE.LT.1) GO TO 40                                           34405700
C         WRITE OUT PARTIAL CONCENTRATIONS ESTIMATED FOR                34405710
C          EACH STABILITY CATEGORY (LIST SEPARATELY THE                 34405720
C          CONTRIBUTIONS FROM POINT AND AREA SOURCES).                  34405730
C                                                                       34405740
      WRITE(IWR,430)                                                    34405750
  430 FORMAT(//,1X,41('*'),' AVERAGE CONCENTRATIONS BY STABILITY ',     34405760
     *       41('*'),//)                                                34405770
      WRITE(IWR,440)(IDUM,IDUM=1,6)                                     34405780
  440 FORMAT(1X,38X,'TYPE OF   -------------STABILITY CATEGORY',        34405790
     *       '--------------',/,                                        34405800
     *       1X,26X,'POLLUTANT   SOURCE',6(6X,I2)/)                     34405810
      KPX(37)=RX*100.                                                   34405820
      KPX(38)=RY*100.                                                   34405830
      DO 470 JDUM=1,2                                                   34405840
         WRITE(IWR,450) JDUM,PNAME(JDUM),(APAR(JDUM,IDUM),IDUM=1,6)     34405850
         WRITE(IPU,455) AROS(JDUM),(APAR(JDUM,IDUM),IDUM=1,6),KPX(37),  34405860
     *                  KPX(38)                                         34405870
  450    FORMAT(1X,26X,I2,' (',A4,')',4X,'AREA ',1X,6(2X,F6.1),/)       34405880
  455    FORMAT(1X,A4,6F7.1,2I8)                                        34405890
         WRITE(IWR,460) JDUM,PNAME(JDUM),(PPAR(JDUM,IDUM),IDUM=1,6)     34405900
         WRITE(IPU,455) PROS(JDUM),(PPAR(JDUM,IDUM),IDUM=1,6),KPX(37),  34405910
     *                  KPX(38)                                         34405920
  460    FORMAT(1X,26X,I2,' (',A4,')',4X,'POINT',1X,6(2X,F6.1),//)      34405930
  470 CONTINUE                                                          34405940
      IBUM = 8                                                          34405950
      IF(N1636.EQ.36) IBUM = 12                                         34405960
      WRITE(IWR,480)                                                    34405970
  480 FORMAT(/,1X,42('*'),' AREA ROSES (MICROGRAMS/CU. METER) ',        34405980
     *       42('*'),//)                                                34405990
      IF (N1636 .EQ. 16) WRITE(IWR,490)(D16(I),I=1,2*N1636,2)           34406000
  490 FORMAT(1X,6X,'POLLUTANT',5X,4(A4,A4,3X,A4,1X,A4,4X)/)             34406010
      IF (N1636 .EQ. 36) WRITE(IWR,500)(ISECTR,ISECTR+18, ISECTR=1,18)  34406020
  500 FORMAT(1X,'POLLUTANT',3X,18(I2,'&',I2,1X)/)                       34406030
      DO 550 J=1,2                                                      34406040
         DO 510 I=1,N1636                                               34406050
            KPX(I)=AROSE(I,J)+0.5                                       34406060
  510    CONTINUE                                                       34406070
         IJ = 0                                                         34406080
  520    IJ = IJ + 1                                                    34406090
         ISTART = (IJ-1)*IBUM + 1                                       34406100
         IFIN = (IJ-1)*IBUM + IBUM                                      34406110
         WRITE(IPU,560) AROS(J),(KPX(I),I=ISTART,IFIN),KPX(37),KPX(38)  34406120
         IF(IFIN.LT.N1636) GO TO 520                                    34406130
         IF (N1636 .EQ. 16) WRITE(IWR,530)J,(KPX(I),I=1,N1636)          34406140
  530    FORMAT(1X,10X,I1,5X,16I6,/)                                    34406150
         IF (N1636 .EQ. 36) WRITE(IWR,540)J,(KPX(I),I=1,N1636/2),       34406160
     *                                    (KPX(I),I=N1636/2+1,N1636)    34406170
  540    FORMAT(1X,4X,I1,6X,18I6,/,1X,11X,18I6,/)                       34406180
  550 CONTINUE                                                          34406190
  560 FORMAT(1X,A4,8I5,2I8)                                             34406200
      WRITE(IWR,570)                                                    34406210
  570 FORMAT(/,1X,41('*'),' POINT ROSES (MICROGRAMS/CU. METER) ',       34406220
     *       42('*'),//)                                                34406230
      IF (N1636 .EQ. 16) WRITE(IWR,490)(D16(I),I=1,2*N1636,2)           34406240
      IF (N1636 .EQ. 36) WRITE(IWR,500)(ISECTR,ISECTR+18, ISECTR=1,18)  34406250
      DO 600 L=1,2                                                      34406260
         DO 580 K=1,N1636                                               34406270
            KPX(K)=PROSE(K,L)+0.5                                       34406280
  580    CONTINUE                                                       34406290
         IJ = 0                                                         34406300
  590    IJ = IJ + 1                                                    34406310
         ISTART = (IJ-1)*IBUM + 1                                       34406320
         IFIN = (IJ-1)*IBUM + IBUM                                      34406330
         WRITE(IPU,560) PROS(L),(KPX(I),I=ISTART,IFIN),KPX(37),KPX(38)  34406340
         IF(IFIN.LT.N1636) GO TO 590                                    34406350
         IF (N1636 .EQ. 16) WRITE(IWR,530)L,(KPX(I),I=1,N1636)          34406360
         IF (N1636 .EQ. 36) WRITE(IWR,540)L,(KPX(I),I=1,N1636/2),       34406370
     *                                    (KPX(I),I=N1636/2+1,N1636)    34406380
  600 CONTINUE                                                          34406390
      WRITE(IWR,610)                                                    34406400
  610 FORMAT(1X,119('*'))                                               34406410
      IPG = 70                                                          34406420
C                                                                       34406430
C         GO BACK AND READ NEXT RECEPTOR                                34406440
C                                                                       34406450
      GO TO 40                                                          34406460
C                                                                       34406470
  620 STOP                                                              34406480
      END                                                               34406490
C                                                                       34415230
C********************************************************************** 34415240
C                                                                       34415250
C
      SUBROUTINE AREA                                                   34415260
C                                                                       34415270
C                                                                       34415280
C         THIS SUBROUTINE CALCULATES THE SECTOR CONCENTRATION FROM THE  34415290
C          AREA SOURCE VECTOR (Q).                                      34415300
C                                                                       34415310
      PARAMETER (NPTS=200,NQLIM=100,NASE=50,NASN=50)                    34415320
      DIMENSION C(2)                                                    34415330
      COMMON /C1/ K,MX,MN,F(6,6,36),UBAR(6),U(6),RI,RJ,INC(4),DELR      34415340
      COMMON /C2/ UE(6),YD,YN,TMN,DINT,YCON,TA(4),IPG,XG,YG,IRD         34415350
      COMMON /C3/ IRUN,CA(2),CB(2),TK(36),AROS(2),PROS(2),TANG          34415360
      COMMON /C4/ DECAY(2),ICA(6),ICP(6),HL(6),HX(6),GB(2),NQ,IVER,IWR  34415370
      COMMON /C5/ Q(NQLIM,4),GA(2),IAD(4,5),IAS,TDA,TDB,TDC,IPU         34415380
      COMMON /ACOM/ PI,SZA(6),ABAR(2),AROSE(36,2),XS(6)                 34415390
      COMMON /SET/ N1636,DELTA,TTAN,NP50,NPDH,NSTDW,NGRAD,KLOW,KHIGH,   34415400
     *             PPAR(2,6),APAR(2,6),WHA(6),FAC,RCEPTZ,KELVIN,NGREG   34415410
      Y=YD                                                              34415420
C                                                                       34415430
C         LOOP OVER STABILITY CLASS                                     34415440
C                                                                       34415450
      DO 170 IS=1,6                                                     34415460
C         IS: CONTROLS STABILITY CLASS                                  34415470
      IF(IS.EQ.5) Y=YN                                                  34415480
      IC=ICA(IS)                                                        34415490
C                                                                       34415500
C         LOOP OVER WIND SPEED CLASS                                    34415510
C                                                                       34415520
      DO 170 IU=1,6                                                     34415530
C         IU: CONTOLS WIND SPEED CLASS                                  34415540
C          IF FREQUENCY IS ZERO, SKIP                                   34415550
      IF(F(IS,IU,K).LE.0.) GO TO 170                                    34415560
C                                                                       34415570
C         INITIALIZATION                                                34415580
C                                                                       34415590
      C(1)=0.                                                           34415600
      C(2)=0.                                                           34415610
      IR=1                                                              34415620
      DVLRI=Q(2,4)-Q(1,4)                                               34415630
   10 R=Q(IR,4)                                                         34415640
      DVLR=DVLRI                                                        34415650
      DVLRI=Q(IR+1,4)-R                                                 34415660
      QQQ = 0.1*Q(IR,3)*FAC                                             34415670
      IF(QQQ.LT.0.1) QQQ = 0.1                                          34415680
      PQQQ = UE(IS)                                                     34415690
      WZ = QQQ**PQQQ                                                    34415700
      WS=U(IU)*WZ                                                       34415710
      DO 20 JA=1,2                                                      34415720
         DF=WS*GA(JA)                                                   34415730
         IF (DF.NE.0.0) THEN                                            9240000
            DECAY(JA)=EXP(R/DF)                                         92415740
         ELSE                                                           9240000
            DECAY(JA)=0.0                                               9240000
         ENDIF                                                          9240000
   20 CONTINUE                                                          9240000
      RXS=R+XS(IS)                                                      34415750
C                                                                       34415760
      CALL SIGMAZ(KLOW,NPDH,IC,RXS,0.0,SZ)                              34415770
C                                                                       34415780
      IF(SZ.LE.0.) GO TO 140                                            34415790
C                                                                       34415800
C         IF THE VERTICAL DISPERSION PARAMETER IS GREATER THAN OR       34415810
C          EQUAL TO 0.8 X MIXING HEIGHT COMPUTE CONCENTRATION USING     34415820
C          A BOX MODEL                                                  34415830
C                                                                       34415840
      IF(SZ.GE.HX(IS)) GO TO 30                                         34415850
C                                                                       34415860
C         LID HAS NOT BEEN REACHED; COMPUTE CONCENTRATION BY GAUSSIAN   34415870
C          FORMULA.                                                     34415880
C                                                                       34415890
      STK1 = Q(IR,3)*WHA(IU) + RCEPTZ                                   34415900
      STK2 = Q(IR,3)*WHA(IU) - RCEPTZ                                   34415910
      SB1 = -0.5*STK1*STK1/(SZ*SZ)                                      34415920
      SB2 = -0.5*STK2*STK2/(SZ*SZ)                                      34415930
      SWW = 0.5*(EXP(SB1) + EXP(SB2))                                   34415940
      S = PI*SWW/(SZ*WS)                                                34415950
      GO TO 100                                                         34415960
C                                                                       34415970
C         LID HAS BEEN REACHED; COMPUTE CONCENTRATION USING A BOX MODEL 34415980
C                                                                       34415990
   30 IRI=IR                                                            34416000
   40 R=Q(IRI,4)                                                        34416010
      DVLR=DVLRI                                                        34416020
      DVLRI=Q(IRI+1,4)-R                                                34416030
      QQQ = 0.1*Q(IRI,3)*FAC                                            34416040
      IF(QQQ.LT.0.1) QQQ = 0.1                                          34416050
      PQQQ = UE(IS)                                                     34416060
      WZ = QQQ**PQQQ                                                    34416070
      WS=U(IU)*WZ                                                       34416080
      S=1./(WS*HL(IS))                                                  34416090
      DO 50 JB=1,2                                                      34416100
         DF=WS*GA(JB)                                                   34416110
         IF (DF.NE.0.0) THEN                                            9240000
            DECAY(JB)=EXP(R/DF)                                         92416120
         ELSE                                                           9240000
            DECAY(JB)=0.0                                               9240000
         ENDIF                                                          9240000
   50 CONTINUE                                                          9240000
      IF(IRI.EQ.1.OR.IRI.EQ.NQ) GO TO 70                                34416130
      DO 60 JC=1,2                                                      34416140
         IF (DECAY(JC).NE.0.0) THEN                                     9240000
            C(JC)=C(JC)+(Q(IRI,JC)*S*(DVLR+DVLRI))/DECAY(JC)            92416150
         ENDIF                                                          9240000
   60 CONTINUE                                                          9240000
      GO TO 90                                                          34416160
C         TRAPEZOIDAL INTEGRATION APPLIED                               34416170
   70 DO 80 JF=1,2                                                      34416180
         IF (DECAY(JF).NE.0.0) THEN                                     9240000
            C(JF)=C(JF)+(Q(IRI,JF)*S*DVLR)/DECAY(JF)                    92416190
         ENDIF                                                          9240000
   80 CONTINUE                                                          9240000
   90 IRI=IRI+1                                                         34416200
C         LOOPS TO RHO(MAX)                                             34416210
      IF(IRI.LE.NQ) GO TO 40                                            34416220
      GO TO 150                                                         34416230
  100 IF(IR.EQ.1.OR.IR.EQ.NQ) GO TO 120                                 34416240
C                                                                       34416250
C         LID HAS NOT BEEN REACHED                                      34416260
C          TRAPEZOIDAL INTEGRATION APPLIED                              34416270
C                                                                       34416280
      DO 110 JI=1,2                                                     34416290
         IF (DECAY(JI).NE.0.0) THEN                                     9240000
            C(JI)=C(JI)+(Q(IR,JI)*S*(DVLR+DVLRI))/DECAY(JI)             92416300
         ENDIF                                                          9240000
  110 CONTINUE                                                          9240000
      GO TO 140                                                         34416310
C         TRAPEZOIDAL INTEGRATION APPLIED                               34416320
  120 DO 130 JK=1,2                                                     34416330
         IF (DECAY(JK).NE.0.0) THEN                                     9240000
            C(JK)=C(JK)+(Q(IR,JK)*S*DVLR)/DECAY(JK)                     92416340
         ENDIF                                                          9240000
  130 CONTINUE                                                          9240000
  140 IR=IR+1                                                           34416350
C         LOOPS TO RHO(MAX)                                             34416360
      IF(IR.LE.NQ) GO TO 10                                             34416370
C                                                                       34416380
C         STORE CONCENTRATION ACCORDING TO WIND DIRECTION SECTOR        34416390
C                                                                       34416400
  150 X=Y*YCON*F(IS,IU,K)                                               34416410
      DO 160 JL=1,2                                                     34416420
         AROSE(K,JL)=AROSE(K,JL)+C(JL)*X                                34416430
         APAR(JL,IS) = APAR(JL,IS) + C(JL)*X                            34416440
  160    ABAR(JL)=ABAR(JL)+C(JL)*X                                      34416450
  170 CONTINUE                                                          34416460
      RETURN                                                            34416470
      END                                                               34416480
C                                                                       34421560
C********************************************************************** 34421570
C                                                                       34421580
      BLOCK DATA                                                        34421590
C                                                                       34421600
      PARAMETER (NPTS=200,NQLIM=100,NASE=50,NASN=50)                    34421610
      COMMON /C1/ K,MX,MN,F(6,6,36),UBAR(6),U(6),RI,RJ,INC(4),DELR      34421620
      COMMON /C2/ UE(6),YD,YN,TMN,DINT,YCON,TA(4),IPG,XG,YG,IRD         34421630
      COMMON /C3/ IRUN,CA(2),CB(2),TK(36),AROS(2),PROS(2),TANG          34421640
      COMMON /C4/ DECAY(2),ICA(6),ICP(6),HL(6),HX(6),GB(2),NQ,IVER,IWR  34421650
      COMMON /C5/ Q(NQLIM,4),GA(2),IAD(4,5),IAS,TDA,TDB,TDC,IPU         34421660
      COMMON /QCOM/ N,DR,IX,IY,TT(36,21),KTC,IXX,IYY,RAD,TD,            34421670
     *              Z(NASE,NASN,3)                                      34421680
      COMMON /ACOM/ PI,SZA(6),ABAR(2),AROSE(36,2),XS(6)                 34421690
      COMMON /PCOM/ PH(NPTS),PR(NPTS),PS(NPTS,4),PX(NPTS),PY(NPTS),     34421700
     *              WA(36),WB(36),PROSE(36,2),CV,IPS,RAT,PBAR(2),TOA,   34421710
     *              VS1(NPTS),T1(NPTS),D1(NPTS),FRN(NPTS),BFLUX(NPTS)   34421720
      COMMON /SET/ N1636,DELTA,TTAN,NP50,NPDH,NSTDW,NGRAD,KLOW,KHIGH,   34421730
     *             PPAR(2,6),APAR(2,6),WHA(6),FAC,RCEPTZ,KELVIN,NDEF    34421740
      COMMON /TITLE/ HEADNG(20),PNAME(2),D16(32),D36(72),DISP(8,7),     34421750
     *               TTITLE(3)                                          34421760
      CHARACTER*4 HEADNG,PNAME,D16,D36,DISP,TTITLE                      9240000
      DATA YCON/0.1E7/                                                  34421770
      DATA INC,IPG,IPS,IX,IY/1,2,4,4,70,0,1,1/                          34421780
      DATA IXX,IYY,IAS/1,1,0/,TD/0.1E-3/                                34421790
      DATA RAD,PI/57.2958,0.797885/                                     34421800
      DATA IAD/0,0,1,1,0,1,0,1,4*0,4*1,0,1,1,0/                         34421810
      DATA IVER/85293/                                                  34421820
      DATA D16/' N  ','    ',' NNE','    ',' NE ','    ',' ENE','    ', 34421830
     *         ' E  ','    ',' ESE','    ',' SE ','    ',' SSE','    ', 34421840
     *         ' S  ','    ',' SSW','    ',' SW ','    ',' WSW','    ', 34421850
     *         ' W  ','    ',' WNW','    ',' NW ','    ',' NNW','    '/ 34421860
      DATA D36/'000-','010 ','010-','020 ','020-','030 ','030-','040 ', 34421870
     *         '040-','050 ','050-','060 ','060-','070 ','070-','080 ', 34421880
     *         '080-','090 ','090-','100 ','100-','110 ','110-','120 ', 34421890
     *         '120-','130 ','130-','140 ','140-','150 ','150-','160 ', 34421900
     *         '160-','170 ','170-','180 ','180-','190 ','190-','200 ', 34421910
     *         '200-','210 ','210-','220 ','220-','230 ','230-','240 ', 34421920
     *         '240-','250 ','250-','260 ','260-','270 ','270-','280 ', 34421930
     *         '280-','290 ','290-','300 ','300-','310 ','310-','320 ', 34421940
     *         '320-','330 ','330-','340 ','340-','350 ','350-','360 '/ 34421950
      DATA DISP/'BRIG','GS-R','URAL',', GI','FFOR','D (1','976)','    ',34421960
     *          'BRIG','GS-U','RBAN',', GI','FFOR','D (1','976)','    ',34421970
     *          'BNL,',' SIN','GER ','AND ','SMIT','H (1','966)','    ',34421980
     *          'KLUG',', VO','GT (','1977',')   ','    ','    ','    ',34421990
     *          'ST. ','LOUI','S, V','OGT ','(197','7)  ','    ','    ',34422000
     *          'PGCD','M, B','USSE',' & Z','IMME','RMAN',' (19','73) ',34422010
     *          'PGSI','G, P','ASQU','ILL,','GIFF','ORD(','1961',',60)'/34422020
      DATA TTITLE/' F) ',' C) ',' K) '/                                 34422030
      END                                                               34422040
C                                                                       34413470
C********************************************************************** 34413480
C                                                                       34413490
C
      SUBROUTINE CALQ                                                   34413500
C                                                                       34413510
      PARAMETER (NPTS=200,NQLIM=100,NASE=50,NASN=50)                    34413520
      DIMENSION C(3)                                                    34413530
      COMMON /C1/ K,MX,MN,F(6,6,36),UBAR(6),U(6),RI,RJ,INC(4),DELR      34413540
      COMMON /C2/ UE(6),YD,YN,TMN,DINT,YCON,TA(4),IPG,XG,YG,IRD         34413550
      COMMON /C3/ IRUN,CA(2),CB(2),TK(36),AROS(2),PROS(2),TANG          34413560
      COMMON /C4/ DECAY(2),ICA(6),ICP(6),HL(6),HX(6),GB(2),NQ,IVER,IWR  34413570
      COMMON /C5/ Q(NQLIM,4),GA(2),IAD(4,5),IAS,TDA,TDB,TDC,IPU         34413580
      COMMON /C6/ ICHK                                                  34413590
      COMMON /QCOM/ N,DR,IX,IY,TT(36,21),KTC,IXX,IYY,RAD,TD,            34413600
     *              Z(NASE,NASN,3)                                      34413610
      COMMON /SET/ N1636,DELTA,TTAN,NP50,NPDH,NSTDW,NGRAD,KLOW,KHIGH,   34413620
     *             PPAR(2,6),APAR(2,6),WHA(6),FAC,RCEPTZ,KELVIN,NDEF    34413630
C         CALCULATE SECTOR AREA SOURCE VECTOR Q(NQ,I)                   34413640
C            N = INDEX OF RADIAL ARC                                    34413650
C            I = 1: P 1 EMISSION RATE                                   34413660
C            I = 2: P 2 EMISSION RATE                                   34413670
C            I = 3: AREA STACK HEIGHT                                   34413680
C                                                                       34413690
C         INITIALIZE ARC COUNTER                                        34413700
C                                                                       34413710
      NQ=0                                                              34413720
C                                                                       34413730
C         INCREMENT ARC COUNTER                                         34413740
C                                                                       34413750
   10 NQ=NQ+1                                                           34413760
C                                                                       34413770
C         IF THE NUMBER OF ARCS EVALUATED IS LESS THAN THE LIMIT SET    34413780
C          BY CDM-2.0 (NQLIM) GO TO 30                                  34413790
C                                                                       34413800
      IF(NQ.LT.NQLIM) GO TO 30                                          34413810
C                                                                       34413820
C         THE NUMBER OF ARCS EXCEEDS THE LIMIT SET BY CDM-2.0 PRINT ERR 34413830
C          MESSAGE AND RETURN TO MAIN                                   34413840
C                                                                       34413850
      NQ = NQLIM - 1                                                    34413860
      IF(ICHK.EQ.1) GO TO 330                                           34413870
      ICHK = 1                                                          34413880
      Q(NQ+1,4) = (N-1)*DELR                                            34413890
      XDIS = Q(NQ+1,4)/1000.0                                           34413900
C         PRINT WARNING MESSAGE                                         34413910
      WRITE(IWR,20) NQLIM,XDIS                                          34413920
   20 FORMAT('0',9X,'WARNING:  MORE THAN',I4,'ARCS ARE REQUIRED FOR ',  34413930
     *  'CALCULATION OF AREA CONTRIBUTION.',/,20X,'AREA SOURCES BEYOND',34413940
     *   1X,F5.1,'KM ARE NOT INCLUDED IN THIS CALCULATION.')            34413950
      GO TO 340                                                         34413960
C                                                                       34413970
C         THE NUMBER OF ARCS IS WITHIN THE LIMITS SET BY CDM-2.0.       34413980
C                                                                       34413990
   30 DO 40 I=1,3                                                       34414000
         Q(NQ+1,I) = 0.0                                                34414010
   40    Q(NQ,I)=0.                                                     34414020
      Q(NQ,4)=(N-1)*DELR                                                34414030
      R=(N-1)*DR                                                        34414040
C         R:   RADIAL UPWIND DISTANCE                                   34414050
      KT=(N-1)*DELR/2500.+1.                                            34414060
C         KT:  CONTROLS INCREMENT TO NEXT ARC                           34414070
      IF(KT.GT.4) KT=4                                                  34414080
      HN=0.                                                             34414090
C                                                                       34414100
C         LOOP OVER SECTOR INTERVAL COUNTER                             34414110
C          KTC: CONTROLS NUMBER OF POINTS ALONG ARC (DINT+1)            34414120
C                                                                       34414130
      DO 290 LL=1,KTC                                                   34414140
      T=TT(K,LL)                                                        34414150
      TI=RI+R*COS(T)                                                    34414160
      TJ=RJ+R*SIN(T)                                                    34414170
C                                                                       34414180
C         IF RADIAL ARC OUTSIDE OUTSIDE AREA EMISSION GRID GO TO 290    34414190
C          DETERMINE WHICH AREA SOURCE THE POINT FALLS ON.  IF ON THE   34414200
C          LINE TWO ARE AVERAGED.  IF ON AN INTERSECTION, FOUR ARE      34414210
C          AVERAGED.                                                    34414220
C                                                                       34414230
      IF(TI.LT.TDA.OR.TI.GT.TDB) GO TO 290                              34414240
      IF(TJ.LT.TDA.OR.TJ.GT.TDC) GO TO 290                              34414250
C                                                                       34414260
C         DETERMINE WHICH AREA SOURCE THE POINT FALLS ON                34414270
C                                                                       34414280
      I=TI                                                              34414290
      J=TJ                                                              34414300
      IF(I.LT.1) I=1                                                    34414310
      IF(J.LT.1) J=1                                                    34414320
      D=TI-I                                                            34414330
      IF(ABS(D-0.5).LE.TD) GO TO 50                                     34414340
      IF(D-0.5)90,50,130                                                34414350
   50 D=TJ-J                                                            34414360
      IF(ABS(D-0.5).LE.TD) GO TO 60                                     34414370
      IF(D-0.5)70,60,80                                                 34414380
   60 IA=1                                                              34414390
      JA=5                                                              34414400
      GO TO 170                                                         34414410
   70 IA=2                                                              34414420
      JA=3                                                              34414430
      GO TO 170                                                         34414440
   80 IA=2                                                              34414450
      JA=4                                                              34414460
      GO TO 170                                                         34414470
   90 D=TJ-J                                                            34414480
      IF(ABS(D-0.5).LE.TD) GO TO 100                                    34414490
      IF(D-0.5)110,100,120                                              34414500
  100 IA=3                                                              34414510
      JA=2                                                              34414520
      GO TO 170                                                         34414530
  110 IA=3                                                              34414540
      JA=3                                                              34414550
      GO TO 170                                                         34414560
  120 IA=3                                                              34414570
      JA=4                                                              34414580
      GO TO 170                                                         34414590
  130 D=TJ-J                                                            34414600
      IF(ABS(D-0.5).LE.TD) GO TO 140                                    34414610
      IF(D-0.5)150,140,160                                              34414620
  140 IA=4                                                              34414630
      JA=2                                                              34414640
      GO TO 170                                                         34414650
  150 IA=4                                                              34414660
      JA=3                                                              34414670
      GO TO 170                                                         34414680
  160 IA=4                                                              34414690
      JA=4                                                              34414700
  170 CN=0.                                                             34414710
      IF(I.EQ.IXX) IA=3                                                 34414720
      IF(J.EQ.IYY) JA=3                                                 34414730
      DO 180 LD=1,3                                                     34414740
  180    C(LD)=0.                                                       34414750
      DO 200 IR=1,4                                                     34414760
         IV=I+IAD(IR,IA)                                                34414770
         JV=J+IAD(IR,JA)                                                34414780
         DO 190 L=1,2                                                   34414790
  190       C(L)=C(L)+Z(IV,JV,L)                                        34414800
         IF(Z(IV,JV,3).LE.0.1) GO TO 200                                34414810
         CN=CN+1.                                                       34414820
         C(3)=C(3)+Z(IV,JV,3)                                           34414830
  200 CONTINUE                                                          34414840
      C(1)=C(1)/4.                                                      34414850
      C(2)=C(2)/4.                                                      34414860
      IF(CN.GT.0.5) GO TO 210                                           34414870
      C(3)=1.                                                           34414880
      GO TO 220                                                         34414890
  210 C(3)=C(3)/CN                                                      34414900
  220 IF(R.GT.0.) GO TO 240                                             34414910
      DO 230 LA=1,3                                                     34414920
  230    Q(NQ,LA)=C(LA)                                                 34414930
      GO TO 320                                                         34414940
  240 IF(LL.NE.1.AND.LL.NE.KTC) GO TO 260                               34414950
C         TRAPEZOIDAL INTEGRATION APPLIED                               34414960
      DO 250 LB=1,2                                                     34414970
  250    C(LB)=C(LB)*0.5                                                34414980
  260 DO 270 LC=1,2                                                     34414990
  270    Q(NQ,LC)=Q(NQ,LC)+C(LC)                                        34415000
      IF(C(1)+C(2).LE.0.) GO TO 290                                     34415010
      Q(NQ,3)=Q(NQ,3)+C(3)                                              34415020
  280 HN=HN+1.                                                          34415030
  290 CONTINUE                                                          34415040
C                                                                       34415050
C         COMPUTE AVERAGE EMISSION RATE OVER THE ARC                    34415060
C                                                                       34415070
      DO 300 LD=1,2                                                     34415080
  300    Q(NQ,LD)=Q(NQ,LD)/DINT                                         34415090
      IF(HN.GT.0.5) GO TO 310                                           34415100
      Q(NQ,3)=1.                                                        34415110
      GO TO 320                                                         34415120
  310 Q(NQ,3)=Q(NQ,3)/HN                                                34415130
  320 N=N+INC(KT)                                                       34415140
C                                                                       34415150
C         IF NEXT ARC IS WITHIN AREA GRID, GO TO 10 AND INCREMENT ARC   34415160
C          COUNTER                                                      34415170
C                                                                       34415180
      IF(N.LE.MX+1) GO TO 10                                            34415190
  330 Q(NQ+1,4)=(N-1)*DELR                                              34415200
  340 RETURN                                                            34415210
      END                                                               34415220
C                                                                       34406500
C********************************************************************** 34406510
C                                                                       34406520
C
      SUBROUTINE CLINT(ICOND)                                           34406530
C                                                                       34406540
      PARAMETER (NPTS=200,NQLIM=100,NASE=50,NASN=50)                    34406550
      DIMENSION FMETEO(16),FSOURC(16),DUM(6),CURVE(7),PCURVE(6),        34406560
     *          ACURVE(6)                                               34406570
      COMMON /C1/ K,MX,MN,F(6,6,36),UBAR(6),U(6),RI,RJ,INC(4),DELR      34406580
      COMMON /C2/ UE(6),YD,YN,TMN,DINT,YCON,TA(4),IPG,XG,YG,IRD         34406590
      COMMON /C3/ IRUN,CA(2),CB(2),TK(36),AROS(2),PROS(2),TANG          34406600
      COMMON /C4/ DECAY(2),ICA(6),ICP(6),HL(6),HX(6),GB(2),NQ,IVER,IWR  34406610
      COMMON /C5/ Q(NQLIM,4),GA(2),IAD(4,5),IAS,TDA,TDB,TDC,IPU         34406620
      COMMON /QCOM/ N,DR,IX,IY,TT(36,21),KTC,IXX,IYY,RAD,TD,            34406630
     *              Z(NASE,NASN,3)                                      34406640
      COMMON /ACOM/ PI,SZA(6),ABAR(2),AROSE(36,2),XS(6)                 34406650
      COMMON /PCOM/ PH(NPTS),PR(NPTS),PS(NPTS,4),PX(NPTS),PY(NPTS),     34406660
     *              WA(36),WB(36),PROSE(36,2),CV,IPS,RAT,PBAR(2),TOA,   34406670
     *              VS1(NPTS),T1(NPTS),D1(NPTS),FRN(NPTS),BFLUX(NPTS)   34406680
      COMMON /SET/ N1636,DELTA,TTAN,NP50,NPDH,NSTDW,NGRAD,KLOW,KHIGH,   34406690
     *             PPAR(2,6),APAR(2,6),WHA(6),FAC,RCEPTZ,KELVIN,NDEF    34406700
      COMMON /TITLE/ HEADNG(20),PNAME(2),D16(32),D36(72),DISP(8,7),     34406710
     *               TTITLE(3)                                          34406720
      CHARACTER*4 HEADNG,PNAME,D16,D36,DISP,TTITLE                      9240000
      CHARACTER*4 CURVE,PCURVE,ACURVE                                   9240000
      DATA CURVE /'  A ','  B ','  C ',' D1 ',' D2 ','  E ','  F '/     34406730
      ICOND = 0                                                         34406740
C                                                                       34406750
C         READ RECORD TYPE 1                                            34406760
C                                                                       34406770
      READ(5,5) HEADNG                                                  34406780
C         HEADNG:  DESCRIPTION OR TITLE OF MODEL RUN                    34406790
    5 FORMAT(20A4)                                                      34406800
C                                                                       34406810
C         READ RECORD TYPE 2                                            34406820
C                                                                       34406830
      READ(5,10) NSO2,PNAME                                             34406840
C         NSO2:   POLLUTANT SOURCE NUMBER FOR SO2                       34406850
C         PNAME:  NAMES OF TWO POLLUTANTS TO BE MODELED                 34406860
   10 FORMAT(I1,3X,2A4)                                                 34406870
      IF ((NSO2 .EQ. 0) .OR. (NSO2 .EQ. 1) .OR. (NSO2 .EQ. 2)) GO TO 20 34406880
      WRITE(6,15) NSO2                                                  34406890
   15 FORMAT('0*** VALID VALUES FOR NSO2 ARE 0, 1, OR 2.',/,            34406900
     *       ' *** USER INPUT NSO2 = ',I4)                              34406910
      ICOND = 1                                                         34406920
C                                                                       34406930
C         READ RECORD TYPE 3                                            34406940
C                                                                       34406950
   20 READ(5,25)AROS,PROS,IRUN,NLIST,IRD,IWR,IPU,CA,CB                  34406960
C         AROS:  ALPHA AREA ROSE OUTPUT ID                              34406970
C         PROS:  ALPHA POINT ROSE OUTPUT ID                             34406980
C         IRUN:  USER DEFINED RUN ID NUMBER                             34406990
C         NLIST: CONTROL FOR PRINTED OUTPUT                             34407000
C         IRD:   FORTRAN LOGICAL UNIT NUMBER (READ)                     34407010
C         IWR:   FORTRAN LOGICAL UNIT NUMBER (PRINTER)                  34407020
C         IPU:   FORTRAN LOGICAL UNIT NUMBER (PUNCH)                    34407030
C         CA:    INTERCEPT OF CALIBRATION                               34407040
C         CB:    SLOPE OF CALIBRATION                                   34407050
   25 FORMAT(4A4,5I5,4F9.0)                                             34407060
C                                                                       34407070
C         READ RECORD TYPE 4                                            34407080
C                                                                       34407090
      READ(IRD,*) N1636,NP50,NPDH,NSTDW,NGRAD,FAC,RCEPTZ,KELVIN,NDEF    34407100
C         N1636:  NUMBER OF WIND DIRECTIONS USED IN METEOROLOGICAL JOIN 34407110
C                 FREQUENCY FUNCTION.                                   34407120
C         NP50:   INITIAL DISPERSION OPTION                             34407130
C         NPDH:   BUOYANCY-INDUCED DISPERSION OPTION                    34407140
C         NSTDW:  STACK DOWNWASH OPTION                                 34407150
C         NGRAD:  GRADUAL PLUME RISE OPTION                             34407160
C         FAC:    EFFLUENT RISE OF AREA SOURCES                         34407170
C         RCEPTZ: HEIGHT (M) ABOVE GROUND OF ALL RECEPTORS              34407180
C         KELVIN: UNITS FLAG FOR STACK TEMPERATURE                      34407190
C         NDEF:   DEFAULT OPTION                                        34407200
      IF ((N1636 .EQ. 16) .OR. (N1636 .EQ. 36)) GO TO 40                34407210
      WRITE(IWR,30) N1636                                               34407220
   30 FORMAT('0*** VALID VALUES FOR N1636 ARE 16 OR 36.',/              34407230
     *       ' *** USER INPUT N1636 =',I4)                              34407240
      ICOND = 1                                                         34407250
   40 IF ((FAC .GE. 0.) .AND. (FAC .LE. 1.)) GO TO 60                   34407260
      WRITE(IWR,50) FAC                                                 34407270
   50 FORMAT('0*** VALID VALUES FOR FAC RANGE FROM 0 TO 1.',/           34407280
     *       ' *** USER INPUT FAC =',F6.2)                              34407290
      ICOND = 1                                                         34407300
C                                                                       34407310
C              RECORD TYPE 5                                            34407320
C                                                                       34407330
   60 READ(IRD,*) KLOW,ICA                                              34407340
C         KLOW:   DISPERSION PARAMETER SCHEME FOR AREA SOURCES          34407350
C         ICA:    ARRAY OF SIX (6) VALUES DEFINING DISPERSION CURVES    34407360
C                   (AS DEFINED BY KLOW) TO BE USED FOR THE SIX         34407370
C                   STABILITY CATEGORIES SUMMARIZED IN THE JOINT        34407380
C                   FREQUENCY FUNCTION.                                 34407390
      IF (((KLOW .GE. 1).AND.(KLOW .LE. 7)).OR.(NDEF .GT. 0)) GO TO 80  34407400
      WRITE(IWR,70) KLOW                                                34407410
   70 FORMAT('0*** VALID VALUES FOR KLOW RANGE FROM 1 TO 7.',/          34407420
     *       ' *** USER INPUT KLOW =',I4)                               34407430
      ICOND = 1                                                         34407440
   80 DO 100 I = 1,6                                                    34407450
         IF (((ICA(I).GE.1).AND.(ICA(I).LE.7)).OR.(NDEF.GT.0)) GO TO 10034407460
         WRITE(IWR,90) I,ICA(I)                                         34407470
   90    FORMAT('0*** VALID VALUES FOR ICA RANGE FROM 1 TO 7.',/        34407480
     *          ' *** USER INPUT ICA(',I1,') =',I4)                     34407490
         ICOND = 1                                                      34407500
  100 CONTINUE                                                          34407510
C                                                                       34407520
C         READ RECORD TYPE 6                                            34407530
C                                                                       34407540
      READ(IRD,*) KHIGH,ICP                                             34407550
C         KHIGH:  DISPERSION PARAMETER SCHEME FOR POINT SOURCES         34407560
C                   (AS DEFINED BY KHIGH) TO BE USED FOR THE SIX        34407580
C                   STABILITY CATEGORIES SUMMARIZED IN THE JOINT        34407590
C                   FREQUENCY FUNCTION.                                 34407600
      IF (((KHIGH.GE.1).AND.(KHIGH.LE.7)).OR.(NDEF.GT.0)) GO TO 120     34407610
      WRITE(IWR,110) KHIGH                                              34407620
  110 FORMAT('0*** VALID VALUES FOR KHIGH RANGE FROM 1 TO 7.',/         34407630
     *       ' *** USER INPUT KHIGH =',I4)                              34407640
      ICOND = 1                                                         34407650
  120 DO 140 I = 1,6                                                    34407660
         IF (((ICP(I).GE.1).AND.(ICP(I).LE.7)).OR.(NDEF.GT.0)) GO TO 14034407670
         WRITE(IWR,130) I,ICP(I)                                        34407680
  130    FORMAT('0*** VALID VALUES FOR ICP RANGE FROM 1 TO 7.',/        34407690
     *          ' *** USER INPUT ICP(',I1,') =',I4)                     34407700
         ICOND = 1                                                      34407710
  140 CONTINUE                                                          34407720
      IF (ICOND .NE. 0) GO TO 810                                       34407730
C                                                                       34407740
C         INITIALIZE ARRAY SOURCE AND WIND DIRECTION ARRAYS             34407750
C                                                                       34407760
      DO 150 I=1,NASE                                                   34407770
         DO 150 J=1,NASN                                                34407780
C               EFFECTIVE STACK HEIGHT MUST BE GE 1.                    34407790
            Z(I,J,3)=1.                                                 34407800
            DO 150 K=1,2                                                34407810
               Z(I,J,K)=0.                                              34407820
  150 CONTINUE                                                          34407830
      TK(1)=0.                                                          34407840
      DELTA = 22.5                                                      34407850
      IF(N1636.EQ.36) DELTA = 10.0                                      34407860
      RDELTA = DELTA/RAD                                                34407870
      TTAN = TAN(RDELTA/2.0)                                            34407880
      DO 160 I=2,N1636                                                  34407890
         TK(I)=TK(I-1)+DELTA                                            34407900
  160 CONTINUE                                                          34407910
C                                                                       34407920
C         READ RECORD TYPE 7                                            34407930
C                                                                       34407940
      READ(IRD,170)DELR,RAT,CV,XG,YG,TOA,TXX                            34407950
C         DELR:  RADIAL INCREMENT (M)                                   34407960
C         RAT:   WIDTH OF A BASIC EMISSION GRID SQUARE (USER UNITS)     34407970
C         CV:    CONVERSION FACTOR, CV*RAT = EMISSION GRID INTERVAL (M) 34407980
C         XG:    X MAP COORD. OF THE SW CORNER OF THE EMISSION GRID     34407990
C                  ARRAY                                                34408000
C         YG:    Y MAP COORD. OF THE SW CORNER OF THE EMISSION GRID     34408010
C                  ARRAY                                                34408020
C         TOA:   MEAN ATMOSPHERIC TEMPERATURE (DEG C)                   34408030
C         TXX:   WIDTH OF BASIC EMISSION GRID SQUARE (M)                34408040
  170 FORMAT(12F6.0)                                                    34408050
      IF (TXX .EQ. 0) GO TO 175                                         34408060
      CHK = ABS(1.0 - (RAT*CV/TXX))                                     34408070
      IF (CHK .LE. 0.01) GO TO 185                                      34408080
  175 WRITE(IWR,180)                                                    34408090
  180 FORMAT('0*** THE PRODUCT OF RAT AND CV MUST EQUAL TXX.',/         34408100
     *       ' *** THE VALUES PROVIDED BY THE USER DO NOT CONFORM TO ', 34408110
     *       'THIS RELATIONSHIP.')                                      34408120
      ICOND = 1                                                         34408130
      GO TO 810                                                         34408140
C                                                                       34408150
C         COMPUTE MAXIMUM LENGTH (M) OF SIDE OF EMISSION                34408160
C          GRID SQUARE MATRIX ( THE 'Z ARRAY')                          34408170
C                                                                       34408180
  185 TXXTE = NASE*TXX                                                  34408190
      TXXTN = NASN*TXX                                                  34408200
C                                                                       34408210
C         READ RECORD TYPE 8                                            34408220
C                                                                       34408230
      READ(IRD,170)DINT,YD,YN,SZA,GB                                    34408240
C         DINT:   NUMBER OF SEGMENTS DESIRED IN DELTA DEGREE SECTORS.   34408250
C                   RANGES FROM 2 TO 20 INCLUSIVE.                      34408260
C         YD:     RATIO OF THE DAYTIME EMISSION RATE TO THE AVERAGE     34408270
C                   24-HOUR EMISSION RATE                               34408280
C         YN:     RATIO OF THE NIGHTTIME EMISSION RATE TO THE AVERAGE   34408290
C                   24-HOUR EMISSION RATE                               34408300
C         SZA(N): INITIAL SIGMA-Z FOR AREA SOURCES (M)                  34408310
C                   N = STABILITY CLASS                                 34408320
C         GB(N):  DECAY HALF-LIFE (HR) FOR THE TWO POLLUTANTS           34408330
C                   N = POLLUTANT NUMBER                                34408340
      IF ((DINT.GE.2.).AND.(DINT.LE.20.)) GO TO 200                     34408350
      WRITE(IWR,190) DINT                                               34408360
  190 FORMAT('0*** VALID VALUES FOR DINT RANGE FROM 2 TO 20.',/         34408370
     *       ' *** USER INPUT DINT = ',F5.1)                            34408380
      ICOND = 1                                                         34408390
      GO TO 810                                                         34408400
C                                                                       34408410
C         READ RECORD TYPE 9                                            34408420
C                                                                       34408430
  200 READ(IRD,*) (UE(I),I=1,6)                                         34408440
C         UE(I):  ARRAY OF SIX (6) VALUES DEFINING WIND PROFILE         34408450
C                   EXPONENTS TO BE ASSOCIATED WITH THE SIX STABILITY   34408460
C                   CATEGORIES SUMMARIZED IN THE JOINT FREQUENCY        34408470
C                   FUNCTION.  I = STABILITY CLASS                      34408480
C                                                                       34408490
C         READ RECORD TYPE 10                                           34408500
C                                                                       34408510
      READ(IRD,*) (U(I),I=1,6)                                          34408520
C         U(I):   ARRAY OF SIX (6) VALUES DEFINING WIND SPEEDS (M/SEC)  34408530
C                   TO BE ASSOCIATED WITH THE SIX WIND SPEED CATEGORIES 34408540
C                   SUMMARIZED IN THE JOINT FREQUENCY FUNCTION.         34408550
C                   TYPICALLY THE HARMONIC AVERAGE WIND SPEED IS USED.  34408560
C                                                                       34408570
C         READ RECORD TYPE 11                                           34408580
C                                                                       34408590
      READ(IRD,*) (HL(I),I=1,6)                                         34408600
C         HL(I):   ARRAY OF SIX (6) VALUES DEFINING MIXING HEIGHTS (M)  34408610
C                   TO BE ASSOCIATED WITH THE SIX STABILITY CATEGORIES  34408620
C                   SUMMARIZED IN THE JOINT FREQUENCY FUNCTION.         34408630
C                   I = STABILITY CLASS                                 34408640
C                                                                       34408650
C         READ RECORD TYPE 12                                           34408660
C                                                                       34408670
      READ(IRD,210) FMETEO                                              34408680
  210 FORMAT(16A4)                                                      34408690
C                                                                       34408700
C         READ RECORD TYPE 13                                           34408710
C                                                                       34408720
      DO 220 I=1,6                                                      34408730
         DO 220 K=1,N1636                                               34408740
            READ(IRD,FMETEO)(F(I,J,K),J=1,6)                            34408750
C               F(I,J,K): JOINT FREQUENCY FUNCTION...                   34408760
C                         I = STABILITY CLASS                           34408770
C                         J = WIND SPEED CLASS                          34408780
C                         K = WIND DIRECTION                            34408790
            DO 220 JJ=1,6                                               34408800
               UBAR(I) = UBAR(I) + U(JJ)*F(I,JJ,K)                      34408810
               DUM(I) = DUM(I) + F(I,JJ,K)                              34408820
  220 CONTINUE                                                          34408830
C                                                                       34408840
C         IF NDEF > 0, THEN SET DEFAULT VALUES.                         34408850
C                                                                       34408860
      IF (NDEF.GT.0) CALL DFAULT(NSO2,CA,CB,NP50,NPDH,NSTDW,NGRAD,KLOW, 34408870
     *                           ICA,KHIGH,ICP,SZA,GB,UE)               34408880
C                                                                       34408890
C         COMPUTE AVERAGE WIND SPEED FOR EACH DIRECTION SECTOR          34408900
C                                                                       34408910
      DO 240 II=1,6                                                     34408920
         IF(DUM(II).NE.0.) GO TO 230                                    34408930
            UBAR(II)=0.                                                 34408940
         GO TO 240                                                      34408950
  230       UBAR(II) = UBAR(II)/DUM(II)                                 34408960
  240 CONTINUE                                                          34408970
C                                                                       34408980
C         DEFINE AMBIENT TEMPERATURE, SECTOR INTEGRATION PARAMETERS,    34408990
C          AND POLLUTANT HALF-LIFE.                                     34409000
C                                                                       34409010
      TOA=TOA+273.16                                                    34409020
      DR=DELR/(CV*RAT)                                                  34409030
      KTC=DINT+1.                                                       34409040
      THETA=DELTA/DINT                                                  34409050
      TANG = 90.0 - DELTA/2.0                                           34409060
      DO 250 I=1,N1636                                                  34409070
         B=TK(I)/RAD                                                    34409080
         WB(I)=SIN(B)                                                   34409090
         WA(I)=COS(B)                                                   34409100
         DO 250 J=1,KTC                                                 34409110
            X=TANG-TK(I)+(J-1)*THETA                                    34409120
            IF(X.LT.0.) X=X+360.                                        34409130
            TT(I,J)=X/RAD                                               34409140
  250 CONTINUE                                                          34409150
C         DEFINE HALF LIFE FOR P 1 AND  P 2                             34409160
      GA(1)=GB(1)*3600./0.693                                           34409170
      GA(2)=GB(2)*3600./0.693                                           34409180
C                                                                       34409190
C                                                                       34409210
      DO 270 JA=1,6                                                     34409220
         JB=ICA(JA)                                                     34409230
         WHA(JA) = FAC + (5.0/U(JA))*(1.0-FAC)                          34409240
         HX(JA)=0.8*HL(JA)                                              34409250
         SA=SZA(JA)                                                     34409260
         IF(SA.GT.0.) GO TO 260                                         34409270
         S=0.                                                           34409280
         GO TO 270                                                      34409290
  260    CALL VIRTX(KLOW,NPDH,JB,0.0,SA,S)                              34409300
  270    XS(JA)=S                                                       34409310
C                                                                       34409320
C         EVALUATE PRINTER CONTROL OPTION                               34409330
C                                                                       34409340
      IF(NLIST.LT.0) GO TO 611                                          XXX09350
C                                                                       34409360
C         ECHO SETUP INFORMATION AND METEOROLOGICAL INPUT               34409370
C                                                                       34409380
      WRITE(IWR,280)IRUN,HEADNG                                         34409390
  280 FORMAT('1',35X,'CLIMATOLOGICAL DISPERSION MODEL - VERSION 2.0',/  34409400
     *        1X,53X,'RUN ',I5,//,                                      34409420
     *        1X,20A4,/)                                                34409430
      WRITE(IWR,290)N1636                                               34409440
  290 FORMAT(1X,'TECHNICAL OPTIONS:',/                                  34409450
     *       1X,'    NUMBER OF WIND DIRECTIONS USED IN METEOROLOGICAL ',34409460
     *          'JOINT',/,                                              34409470
     *       1X,'      FREQUENCY FUNCTION (N1636) ',30('.'),I5)         34409480
      WRITE(IWR,300)KLOW,(DISP(I,KLOW), I = 1,8),                       34409490
     *              KHIGH,(DISP(I,KHIGH), I = 1,8)                      34409500
  300 FORMAT(1X,'    DISPERSION PARAMETER SCHEME FOR AREA SOURCES ',    34409510
     *          '(KLOW) ',7('.'),I5,12X,8A4/                            34409520
     *       1X,'    DISPERSION PARAMETER SCHEME FOR POINT SOURCES ',   34409530
     *          '(KHIGH) ',5('.'),I5,12X,8A4)                           34409540
      WRITE(IWR,310)FAC                                                 34409550
  310 FORMAT(1X,'    EFFLUENT RISE FOR AREA SOURCES (FAC) ',22('.'),    34409560
     *          4X,1PE12.6)                                             34409570
      WRITE(IWR,320) RCEPTZ                                             34409580
  320 FORMAT(1X,'    HEIGHT ABOVE GROUND OF ALL RECEPTORS (RCEPTZ) ',   34409590
     *          13('.'),4X,1PE12.6,' M')                                34409600
      WRITE(IWR,330) PNAME(1),CA(1),CB(1)                               34409610
      WRITE(IWR,330) PNAME(2),CA(2),CB(2)                               34409620
  330 FORMAT(1X,'    CALIBRATION CONSTANTS -- ',A4,/,                   34409630
     *       1X,8X,'INTERCEPT OF CALIBRATION ',30('.'),4X,1PE12.6,      34409640
     *          ' MICROGRAMS/CU. METER',/                               34409650
     *       1X,8X,'SLOPE OF CALIBRATION ',34('.'),4X,1PE12.6,          34409660
     *          ' DIMENSIONLESS')                                       34409670
      WRITE(IWR,340)NP50,NPDH,NSTDW,NGRAD,NDEF                          34409680
  340 FORMAT(1X,'    INITIAL DISPERSION OPTION (NP50) ',26('.'),I5,/,   34409690
     *       1X,'    BUOYANCY INDUCED DISPERSION OPTION (NPDH) ',       34409700
     *          17('.'),3X,I2,/                                         34409710
     *       1X,'    STACK DOWNWASH OPTION (NSTDW) ',29('.'),3X,I2,/,   34409720
     *       1X,'    GRADUAL PLUME RISE OPTION (NGRAD) ',25('.'),3X,I2/ 34409730
     *       1X,'    DEFAULT OPTION (NDEF) ',37('.'),3X,I2,/)           34409740
      WRITE(IWR,360) NLIST                                              34409750
  360 FORMAT('0PRINT OPTIONS:',/                                        34409760
     *       1X,'    CONTROL FOR PRINTED OUTPUT ',32('.'),I5)           34409770
      WRITE(IWR,370) IRD,IWR,IPU                                        34409780
  370 FORMAT(1X,'    FORTRAN LOGICAL UNIT NUMBER (READ) ',24('.'),I5/   34409790
     *  1X,'    FORTRAN LOGICAL UNIT NUMBER (PRINTER) ',21('.'),I5/     34409800
     *  1X,'    FORTRAN LOGICAL UNIT NUMBER (PUNCH) ',23('.'),I5/)      34409810
      WRITE(IWR,380)XG                                                  34409820
  380 FORMAT(1X,'OPERATING PARAMETERS:',/                               34409830
     *       1X,'    X-MINIMUM OF AREA EMISSION INVENTORY MAP GRID',    34409840
     *          ' (XG) ',8('.'),4X,1PE12.6,' USER UNITS')               34409850
      WRITE(IWR,390)YG,RAT                                              34409860
  390 FORMAT(1X,'    Y-MINIMUM OF AREA EMISSION INVENTORY MAP GRID',    34409870
     *          ' (YG) ',8('.'),4X,1PE12.6,' USER UNITS',/              34409880
     *       1X,'    WIDTH OF A BASIC EMISSION GRID SQUARE (RAT) ',     34409890
     *          15('.'),4X,1PE12.6,' USER UNITS')                       34409900
  400 FORMAT(1X,'    GRID CONVERSION FACTOR (CV) ',31('.'),             34409920
     *          4X,1PE12.6,' M/USER UNITS'/,                            34409930
     *       1X,'    WIDTH OF A BASIC EMISSION GRID SQUARE (TXX) ',     34409940
     *          15('.'),4X,1PE12.6,' M')                                34409950
      WRITE(IWR,410)DINT                                                34409960
  410 FORMAT(1X,'    NUMBER OF SUBSECTORS CONSIDERED FOR EACH SECT',    34409970
     *          'OR (DINT) ',4('.'),4X,1PE12.6,' DIMENSIONLESS')        34409980
      WRITE(IWR,420)THETA,DELR                                          34409990
  420 FORMAT(1X,'    ANGULAR WIDTH OF A SUBSECTOR (THETA) ',22('.'),    34410000
     *          4X,1PE12.6,' DEG',/                                     34410010
     *       1X,'    INITIAL RADIAL INCREMENT (DELR) ',27('.'),         34410020
     *          4X,1PE12.6,' M'/)                                       34410030
      WRITE(IWR,430)TOA                                                 34410040
  430 FORMAT(1X,'MISCELLANEOUS METEOROLOGICAL DATA:',/                  34410050
     *       1X,'    AMBIENT AIR TEMPERATURE (TOA) ',29('.'),           34410060
     *          4X,1PE12.6,' K')                                        34410070
      WRITE(IWR,440)(I,HL(I),I=1,6)                                     34410080
  440 FORMAT(1X,'    MIXING HEIGHTS BY STABILITY CLASS (HL):',/         34410090
     *       '        STABILITY CLASS:',I6,1X,33('.'),4X,1PE12.6,' M',/ 34410100
     *       5(1X,27X,I2,1X,33('.'),4X,1PE12.6,' M',/))                 34410110
      WRITE(IWR,280)IRUN,HEADNG                                         34410120
      WRITE(IWR,450)                                                    34410130
  450 FORMAT(1X,'MISCELLANEOUS METEOROLOGICAL DATA (CONTINUED):',//,    34410140
     *       1X,'    CENTRAL WIND SPEED OF THE SIX WIND SPEED CLAS',    34410150
     *          'SES (U):')                                             34410160
      WRITE(IWR,460)(I,U(I),I=1,6)                                      34410170
  460 FORMAT(1X,'        WIND SPEED CLASS:  ',I2,1X,33('.'),            34410180
     *          4X,1PE12.6,' M/SEC',/                                   34410190
     *     5(1X,27X,I2,1X,33('.'),4X,1PE12.6,' M/SEC',/))               34410200
      WRITE(IWR,470)(I,UE(I),I=1,6)                                     34410210
  470 FORMAT(1X,'    EXPONENTIAL OF THE VERTICAL WIND PROFILE (UE):'/   34410220
     *       1X,'        STABILITY CLASS:   ',I2,1X,33('.'),            34410230
     *          4X,1PE12.6,' DIMENSIONLESS'/                            34410240
     *     5(1X,27X,I2,1X,33('.'),4X,1PE12.6,' DIMENSIONLESS'/)//)      34410250
      WRITE(IWR,480)PNAME(1),PNAME(2)                                   34410260
  480 FORMAT(1X,'SOURCE DATA:',//,                                      34410270
     *       1X,'    POLLUTANTS TO BE MODELED ',34('.'),4X,A4,' & ',A4) 34410280
      WRITE(IWR,490)PNAME(1),GB(1),PNAME(2),GB(2)                       34410290
  490 FORMAT(1X,'    DECAY HALF-LIFE FOR ',A4,' (GB(1)) ',26('.'),      34410300
     *          4X,1PE12.6,' HR',/                                      34410310
     *       1X,'    DECAY HALF-LIFE FOR ',A4,' (GB(2)) ',26('.'),      34410320
     *          4X,1PE12.6,' HR')                                       34410330
      WRITE(IWR,500)YD,YN                                               34410340
  500 FORMAT(1X,'    DAYTIME EMISSION WEIGHT FACTOR (YD) ',23('.'),     34410350
     *          4X,1PE12.6,' DIMENSIONLESS'/                            34410360
     *       1X,'    NIGHTTIME EMISSION WEIGHT FACTOR (YN) ',21('.'),   34410370
     *          4X,1PE12.6,' DIMENSIONLESS')                            34410380
      WRITE(IWR,510)                                                    34410390
  510 FORMAT(1X,'    INITIAL SIGMA-Z FOR AREA SOURCES (SZA):')          34410400
      WRITE(IWR,520)(I,SZA(I),I=1,6)                                    34410410
  520 FORMAT(1X,'        STABILITY CLASS:   ',I2,1X,33('.'),            34410420
     *          4X,1PE12.6,' M',/                                       34410430
     *     5(1X,27X,I2,1X,33('.'),4X,1PE12.6,' M',/))                   34410440
      DO 530 I = 1,6                                                    34410450
         IDUM = ICP(I)                                                  34410460
         JDUM = ICA(I)                                                  34410470
         PCURVE(I) = CURVE(IDUM)                                        34410480
         ACURVE(I) = CURVE(JDUM)                                        34410490
  530 CONTINUE                                                          34410500
      WRITE(IWR,540) (I,PCURVE(I),ACURVE(I), I = 1,6)                   34410510
  540 FORMAT(1X,'DISPERSION CURVE USED FOR EACH STABILTY CLASS',/,      34410520
     *           4X,'STABILITY        POINT          AREA',/,           34410530
     *           4X,'  CLASS         SOURCES        SOURCES',/,         34410540
     *       6(7X,I2,12X,A4,11X,A4,/))                                  34410550
      DO 610 I=1,6                                                      34410560
         IF((N1636.EQ.16) .AND. ((I/2)*2.EQ.I)) GO TO 560               34410570
         WRITE(IWR,280)IRUN,HEADNG                                      34410580
         WRITE(IWR,550)                                                 34410590
  550    FORMAT(1X,38X,'METEOROLOGICAL JOINT FREQUENCY FUNCTION',//)    34410600
  560    WRITE(IWR,570)I                                                34410610
  570    FORMAT(1X,'STABILITY CLASS',I2,47X,'WIND SPEED CLASS',//       34410620
     *          1X,4X,'WIND DIRECTION    SECTOR',                       34410630
     *          11X,'1',12X,'2',12X,'3',12X,'4',12X,'5',12X,'6',/)      34410640
         DO 590 K=1,N1636                                               34410650
            IF(N1636 .EQ. 36)                                           34410660
     *         WRITE(IWR,580)D36(2*K-1),D36(2*K),K,(F(I,J,K),J=1,6)     34410670
            IF(N1636 .EQ. 16)                                           34410680
     *         WRITE(IWR,580)D16(2*K-1),D16(2*K),K,(F(I,J,K),J=1,6)     34410690
  580          FORMAT(1X,7X,2A4,9X,I2,9X,6(F8.6,5X))                    34410700
  590    CONTINUE                                                       34410710
         WRITE(IWR,600)UBAR(I)                                          34410720
  600    FORMAT(/,1X,55X,'COMPUTED MEAN SPEED = ',F5.2,' M/SEC',2(/))   34410730
  610 CONTINUE                                                          34410740
C                                                                       34410750
C         READ RECORD TYPE 14                                           34410760
C                                                                       34410770
  611 READ(IRD,210) FSOURC                                              XXX10780
      CON1 = FLOAT(N1636)/(2.0*3.14159)                                 34410790
      CON2 = CON1*PI                                                    34410800
C                                                                       34410810
C         READ SOURCE INPUT DATA (I.E., RECORD TYPE 15)                 34410820
C                                                                       34410830
  620 READ(IRD,FSOURC)X,Y,TX,S1,S2,SH,D,VS,T,SA                         34410840
C         X:   X MAP COORDINATE OF SOURCE                               34410850
C         Y:   Y MAP COORDINATE OF SOURCE                               34410860
C         TX:  WIDTH OF AREA SOURCES                                    34410870
C         S1:  EMISSION RATE OF POLLUTANT 1 (G/SEC)                     34410880
C         S2:  EMISSION RATE OF POLLUTANT 2 (G/SEC)                     34410890
C         SH:  SOURCE HEIGHT (M)                                        34410900
C         D:   STACK DIAMETER (M)                                       34410910
C         VS:  EXIT VELOCITY (M/S)                                      34410920
C         T:   STACK GAS TEMPERATURE (DEG F, C, OR K)                   34410930
C         SA:  PLUME RISE OPTION                                        34410940
      IF (NDEF .GT. 0) SA = 0.0                                         34410950
      XSS = X                                                           34410960
      YSS = Y                                                           34410970
C                                                                       34410980
C         TEST END OF SOURCE DATA (BLANK CARD)                          34410990
C                                                                       34411000
      IF(S1+S2.LE.0.) GO TO 790                                         34411010
C                                                                       34411020
C         EVALUATE PRINTER CONTROL OPTION                               34411030
C                                                                       34411040
      IF(NLIST.NE.0) GO TO 680                                          34411050
C                                                                       34411060
C         ECHO SOURCE INPUT DATA                                        34411070
C                                                                       34411080
      IF(IPG.LT.44) GO TO 660                                           34411090
      IPG=0                                                             34411100
      WRITE(IWR,280)IRUN,HEADNG                                         34411110
      WRITE(IWR,630)                                                    34411120
  630 FORMAT(1X,42X,'AREA AND POINT SOURCE INVENTORY',//,               34411130
     *       1X,84X,'STACK     STACK      OPTIONAL',/,                  34411140
     *       1X,27X,'WIDTH OF     ----EMISSION RATE----    SOURCE    ', 34411150
     *       'STACK    EXIT       GAS      PLUME RISE')                 34411160
      WRITE(IWR,640)PNAME(1),PNAME(2)                                   34411170
  640 FORMAT(1X,'  X MAP        Y MAP      GRID SQUARE',5X,A4,9X,A4,6X, 34411180
     *       'HEIGHT    DIAM     SPEED     TEMP     COEFFICIENT')       34411190
      I = 1                                                             34411200
      IF (KELVIN .EQ. 0) I = 2                                          34411210
      IF (KELVIN .GT. 0) I = 3                                          34411220
      WRITE(IWR,650) TTITLE(I)                                          34411230
  650 FORMAT(1X,'COORDINATE   COORDINATE       (M)        (G/SEC)',     34411240
     *       '      (G/SEC)      (M)      (M)    (M/SEC)   (DEG',A4,    34411250
     *       '   (M**2/SEC)',/)                                         34411260
  660 IPG=IPG+1                                                         34411270
      WRITE(IWR,670)X,Y,TX,S1,S2,SH,D,VS,T,SA                           34411280
  670 FORMAT(1X,1X,F7.2,6X,F7.2,7X,F6.0,6X,F8.2,5X,F8.2,4X,F6.2,        34411290
     *       4X,F5.2,4X,F5.2,5X,F5.1,7X,F6.2)                           34411300
C         EFFECTIVE STACK HEIGHT MUST BE GE 1.                          34411310
  680 IF(SH.LT.1.) SH=1.                                                34411320
C                                                                       34411330
C         IF POINT SOURCE THEN GO TO 750                                34411340
C                                                                       34411350
      IF(TX.LE.0.) GO TO 750                                            34411360
C                                                                       34411370
C         SOURCE IS AREA TYPE.  MODIFY SOURCE COORDINATES, DIMENSIONS,  34411380
C          AND EMISSION RATE TO CONFORM TO CDM-2.0 REQUIREMENTS.        34411390
C                                                                       34411400
      D=TX*0.5/CV                                                       34411410
      X=X+D                                                             34411420
      Y=Y+D                                                             34411430
      W=TX/TXX                                                          34411440
      S=TX*TX                                                           34411450
      B=S1/S                                                            34411460
      D=S2/S                                                            34411470
C         BECAUSE OF THE METHOD OF INTEGRATION, AREA SOURCES ARE        34411480
C          DIVIDED BY TWO AT THIS POINT FOR MORE EFFICIENT EXECUTION    34411490
C          OF SUBROUTINE AREA.                                          34411500
      B=B*0.5                                                           34411510
      D=D*0.5                                                           34411520
      X=(X-XG)/RAT+1.                                                   34411530
      Y=(Y-YG)/RAT+1.                                                   34411540
      IF(W.GT.1.) GO TO 690                                             34411550
      M=X                                                               34411560
      N=Y                                                               34411570
      K=M                                                               34411580
      L=N                                                               34411590
      GO TO 700                                                         34411600
  690 S=W*0.5                                                           34411610
      K=(X-S)+0.55                                                      34411620
      L=(Y-S)+0.55                                                      34411630
      M=(K+W)-0.45                                                      34411640
      N=(L+W)-0.45                                                      34411650
  700 CONTINUE                                                          34411660
C                                                                       34411670
C         IF SOURCE DIMENSIONS ARE OUTSIDE CDM-2.0 LIMITS THEN PRINT    34411680
C          ERROR MESSAGE AND READ NEXT SOURCE                           34411690
C                                                                       34411700
      IF (M.GT.NASE.OR.N.GT.NASN) GO TO 710                             34411710
      IF (M.LE.0.OR.N.LE.0) GO TO 710                                   34411720
      IF (L.GT.NASN.OR.K.GT.NASE) GO TO 710                             34411730
      IF (L.LE.0.OR.K.LE.0) GO TO 710                                   34411740
      IF (M.LT.K) GO TO 710                                             34411750
      IF (N.LT.L) GO TO 710                                             34411760
      GO TO 730                                                         34411770
C         PRINT ERROR MESSAGE FOR THIS AREA SOURCE                      34411780
  710 WRITE(IWR,720) XSS,YSS,TXXTE,TXXTN                                34411790
  720 FORMAT('0',7X,'NOTE:  AREA SOURCE WITH X COORD ',F10.2,           34411800
     *  ' AND Y COORD ',F10.2,', VIOLATES',/,15X,                       34411810
     *  'AREA SOURCE ARRAY LIMITS.  AREA SOURCES MUST LIE ENTIRELY ',   34411820
     *  'WITHIN A ',F11.2,' BY ',F11.2,/,15X,                           34411830
     *  'METER SQUARE WITH SOUTHWEST CORNER AT THE USER-DEFINED ',      34411840
     *  'ORIGIN (XG,YG).  THIS',/,15X,                                  34411850
     *  'SOURCE  WILL NOT BE INCLUDED IN THIS CALCULATION.',/)          34411860
      GO TO 620                                                         34411870
C                                                                       34411880
C         STORE AREA SOURCE INFORMATION                                 34411890
C                                                                       34411900
  730 DO 740 I=K,M                                                      34411910
         DO 740 J=L,N                                                   34411920
            Z(I,J,1)=B                                                  34411930
            Z(I,J,2)=D                                                  34411940
  740       Z(I,J,3)=SH                                                 34411950
      IF(M.GT.IXX) IXX=M                                                34411960
      IF(N.GT.IYY) IYY=N                                                34411970
C                                                                       34411980
C         INCREMENT AREA SOURCE COUNTER                                 34411990
C                                                                       34412000
      IAS=IAS+1                                                         34412010
C                                                                       34412020
C         GO BACK AND READ NEXT SOURCE                                  34412030
C                                                                       34412040
      GO TO 620                                                         34412050
C                                                                       34412060
C         INCREMENT POINT SOURCE COUNTER                                34412070
C                                                                       34412080
  750 IPS=IPS+1                                                         34412090
C                                                                       34412100
C         STORE POINT SOURCE INFORMATION                                34412110
C                                                                       34412120
      PX(IPS)=(X-XG)/RAT+0.5                                            34412130
      PY(IPS)=(Y-YG)/RAT+0.5                                            34412140
      PS(IPS,1)=S1*CON2                                                 34412150
      PS(IPS,2)=S2*CON2                                                 34412160
      PS(IPS,3)=S1*CON1                                                 34412170
      PS(IPS,4)=S2*CON1                                                 34412180
      PH(IPS)=SH                                                        34412190
      PR(IPS)=SA                                                        34412200
      IF(KELVIN.GE.0) GO TO 755                                         34412210
      T=(T-32.0)*(5./9.)+273.16                                         34412220
      GO TO 760                                                         34412230
  755 IF(KELVIN.GT.0) GO TO 760                                         34412240
      T=T+273.16                                                        34412250
  760 IF(D .LE. 0.) D = 0.01                                            34412260
      VS1(IPS)=VS                                                       34412270
      T1(IPS) = T                                                       34412280
      D1(IPS) = D                                                       34412290
      FRN(IPS)=VS*VS*TOA/(9.80616*D*(T-TOA))                            34412300
      BFLUX(IPS) = (9.80616 * VS * D * D * (T - TOA))/(4. * T)          34412310
C                                                                       34412320
C         GO BACK AND READ NEXT SOURCE                                  34412330
C                                                                       34412340
      GO TO 620                                                         34412350
C                                                                       34412360
C         PREPARE TO RETURN TO MAIN                                     34412370
C                                                                       34412380
  790 IPG=70                                                            34412390
C                                                                       34412400
C         COMPUTE NE CORNER OF NE GRID SQUARE                           34412410
C                                                                       34412420
      TDA=0.5-TD                                                        34412430
      TDB=IXX+0.5+TD                                                    34412440
      TDC=IYY+0.5+TD                                                    34412450
C                                                                       34412460
C         PRINT NUMBER OF POINT AND AREA SOURCES                        34412470
C                                                                       34412480
      WRITE(IWR,800)IAS,IPS                                             34412490
  800 FORMAT('0',I10,' AREA SOURCES.',I10,' POINT SOURCES.')            34412500
  810 RETURN                                                            34412510
      END                                                               34412520
C                                                                       34412530
C********************************************************************** 34412540
C                                                                       34412550
C
      SUBROUTINE DFAULT(NSO2,CA,CB,NP50,NPDH,NSTDW,NGRAD,KLOW,ICA,KHIGH,34412560
     *                  ICP,SZA,GB,UE)                                  34412570
C                                                                       34412580
C                                                                       34412590
C       PARAMETER LIST:                                                 34412600
C         INPUT:   NSO2  - POLLUTANT NUMBER FOR SO2                     34412610
C         OUTPUT:  CA    - INTERCEPT OF CALIBRATION                     34412620
C                  CB    - SLOPE OF CALIBRATION                         34412630
C                  NP50  - INITIAL DISPERSION OPTION                    34412640
C                  NPDH  - BUOYANCY-INDUCED DISPERSION OPTION           34412650
C                  NSTDW - STACK DOWNWASH OPTION                        34412660
C                  NGRAD - GRADUAL PLUME RISE OPTION                    34412670
C                  KLOW  - DISPERSION PARAMETER SCHEME FOR AREA SOURCES 34412680
C                  ICA   - ARRAY OF SIX VALUES DEFINING DISPERSION      34412690
C                           CURVES (AS DEFINED BY KLOW) TO BE USED FOR  34412700
C                           THE SIX STABILITY CATEGORIES SUMMARIZED IN  34412710
C                           THE JOINT FREQUENCY FUNCTION                34412720
C                  KHIGH - DISPERSION PARAMETER SCHEME FOR POINT SOURCE 34412730
C                  ICP   - ARRAY OF SIX VALUES DEFINING DISPERSION      34412740
C                           CURVES (AS DEFINED BY KHIGH) TO BE USED FOR 34412750
C                           THE SIX STABILITY CATEGORIES SUMMARIZED IN  34412760
C                           THE JOINT FREQUENCY FUNCTION                34412770
C                  SZA   - INITIAL SIGMA-Z FOR AREA SOURCES (METERS)    34412780
C                  GB    - DECAY HALF-LIFE (HRS) FOR THE TWO POLLUTANTS 34412790
C                  UE    - ARRAY OF SIX VALUES DEFINING WIND PROFILE    34412800
C                           EXPONENTS TO BE ASSOCIATED WITH THE SIX     34412810
C                           STABILITY CATEGORIES SUMMARIZED IN THE      34412820
C                           JOINT FREQUENCY FUNCTION.                   34412830
C                                                                       34412840
C       CALLING ROUTINE:                                                34412850
C         CLINT                                                         34412860
C                                                                       34412870
C       DESCRIPTION:                                                    34412880
C         THIS SUBROUTINE SETS PARAMETERS ACCORDING TO REGULATORY       34412890
C         GUIDANCE ESTABLISHED IN "GUIDELINE ON AIR QUALITY MODELS."    34412900
C         THIS MODULE WAS ADDED TO THE CODE AS A CONVENIENCE FOR THE    34412910
C         USER TO HELP AVOID INADVERTANT ERRORS IN SETTING THE          34412920
C         APPROPRIATE OPTIONS FOR REGULATORY USES.                      34412930
C                                                                       34412940
      DIMENSION CA(2),CB(2),ICA(6),ICP(6),SZA(6),GB(2),UE(6)            34412950
C                                                                       34412960
C         SET CALIBRATION CONSTANTS                                     34412970
C                                                                       34412980
      DO 10 I = 1,2                                                     34412990
         CA(I) = 0.0                                                    34413000
         CB(I) = 1.0                                                    34413010
   10 CONTINUE                                                          34413020
C                                                                       34413030
C         SET PROGRAM CONTROL PARAMETERS                                34413040
C                                                                       34413050
      NP50  = 0                                                         34413060
      NPDH  = 1                                                         34413070
      NSTDW = 1                                                         34413080
      NGRAD = 0                                                         34413090
C                                                                       34413100
C         SET DISPERSION SCHEME, DISPERSION CURVES, AND INITIAL SIGMAS  34413110
C                                                                       34413120
      KLOW  = 2                                                         34413130
      KHIGH = 2                                                         34413140
      DO 20 I = 1,6                                                     34413150
         ICA(I) = I                                                     34413160
         ICP(I) = I                                                     34413170
         SZA(I) = 30.                                                   34413180
   20 CONTINUE                                                          34413190
C                                                                       34413200
C         SET WIND PROFILE EXPONENTS                                    34413210
C                                                                       34413220
      UE(1) = .15                                                       34413230
      UE(2) = .15                                                       34413240
      UE(3) = .20                                                       34413250
      UE(4) = .25                                                       34413260
      UE(5) = .25                                                       34413270
      UE(6) = .30                                                       34413280
C                                                                       34413290
C         SET POLLUTANT HALF-LIFE                                       34413300
C                                                                       34413310
      IF ((NSO2 .EQ. 1) .OR. (NSO2 .EQ. 2)) GO TO 30                    34413320
         GB(1) = 999999.                                                34413330
         GB(2) = 999999.                                                34413340
         GO TO 999                                                      34413350
   30 CONTINUE                                                          34413360
      IF (NSO2 .EQ. 2) GO TO 40                                         34413370
         GB(1) = 4.0                                                    34413380
         GB(2) = 999999.                                                34413390
         GO TO 999                                                      34413400
   40 CONTINUE                                                          34413410
         GB(1) = 999999.                                                34413420
         GB(2) = 4.0                                                    34413430
C                                                                       34413440
  999 RETURN                                                            34413450
      END                                                               34413460
C                                                                       34418320
C********************************************************************** 34418330
C                                                                       34418340
C
      SUBROUTINE PLRISE(VS,TS,D,F,T,U,KST,DISTF,DELH)                   34418350
C                                                                       34418360
C                                                                       34418370
C       PARAMETER LIST:                                                 34418380
C         INPUT:   VS    - STACK GAS VELOCITY (M/SEC)                   34418390
C                  TS    - STACK GAS TEMPERATURE (KELVIN)               34418400
C                  D     - STACK INSIDE DIAMETER (METERS)               34418410
C                  F     - BUOYANCY FLUX (M**4/SEC**3)                  34418420
C                  T     - AMBIENT AIR TEMPERATURE (KELVIN)             34418430
C                  U     - WIND SPEED AT STACK HEIGHT (M/SEC)           34418440
C                  KST   - STABILITY CLASS                              34418450
C         OUTPUT:  DISTF - DISTANCE TO FINAL RISE (METERS)              34418460
C                  DELH  - PLUME RISE (METERS)                          34418470
C                                                                       34418480
C       CALLING ROUTINE:                                                34418490
C         POINT                                                         34418500
C                                                                       34418510
C       DESCRIPTION:                                                    34418520
C         THIS SUBROUTINE CALCULATES PLUME RISE ACCORDING TO METHODS BY 34418530
C         BRIGGS (1969, 1971, AND 1975)                                 34418540
C                                                                       34418550
      G = 9.80616                                                       34418560
C                                                                       34418570
C         CALCULATE UNSTABLE-NEUTRAL MOMENTUM RISE REGARDLESS OF        34418580
C          STABILITY                                                    34418590
C                                                                       34418600
      DELHM = 3.0 * VS * D/U                                            34418610
      IF (KST .GT. 5) GO TO 100                                         34418620
C                                                                       34418630
C         PLUME RISE FOR UNSTABLE-NEUTRAL CONDITIONS                    34418640
C                                                                       34418650
      IF (TS .LT. T) GO TO 200                                          34418660
      IF (F .GE. 55.) GO TO 50                                          34418670
C         COMBINATION OF BRIGGS' (1971) EQS. 6&7, PAGE 1031, FOR F < 55 34418680
      DELH = (21.425 * F**0.75)/U                                       34418690
      IF (DELHM .GT. DELH) GO TO 200                                    34418700
      DISTF = 49. * F**0.625                                            34418710
      GO TO 999                                                         34418720
C         COMBIMATION OF BRIGGS' (1971) EQS. 6&7, PAGE 1031, FOR F >= 5 34418730
   50 DELH = (38.71 * F**0.6)/U                                         34418740
      IF (DELHM .GT. DELH) GO TO 200                                    34418750
      DISTF = 119. * F**0.4                                             34418760
      GO TO 999                                                         34418770
C                                                                       34418780
C         PLUME RISE FOR STABLE CONDITIONS                              34418790
C                                                                       34418800
  100 DTHDZ = 0.02                                                      34418810
      IF (KST .GT. 6) DTHDZ = 0.035                                     34418820
      S = G * DTHDZ/T                                                   34418830
C         CALCULATE STABLE MOMENTUM RISE (BRIGGS' (1969) EQ. 4.28,      34418840
C          PAGE 59)                                                     34418850
      DHA = 1.5 * (VS*VS * D*D * T/(4. * TS * U))**0.333333/S**0.166667 34418860
      IF (DHA .LT. DELHM) DELHM = DHA                                   34418870
      IF (TS .LT. T) GO TO 200                                          34418880
C         CALCULATE STABLE BUOYANCY RISE (WITH WIND)                    34418890
      DELH = 2.6 * (F/(U * S))**0.333333                                34418900
C         CALCULATE STABLE BUOYANCY RISE (CALM)                         34418910
      DELHC = 4.0 * F**0.25 / S**0.375                                  34418920
      IF (DELHC .LT. DELH) DELH = DELHC                                 34418930
      IF (DELHM .GT. DELH) GO TO 200                                    34418940
      DISTF = 2.0715 * U/SQRT(S)                                        34418950
      GO TO 999                                                         34418960
C                                                                       34418970
C         CASE WHERE MOMENTUM RISE DOMINATES OR IS GREATER THAN         34418980
C          BUOYANCY RISE                                                34418990
C                                                                       34419000
  200 DELH = DELHM                                                      34419010
      DISTF = 0.0                                                       34419020
C                                                                       34419030
  999 RETURN                                                            34419040
      END                                                               34419050
C                                                                       34416490
C********************************************************************** 34416500
C                                                                       34416510
C
      SUBROUTINE POINT                                                  34416520
C                                                                       34416530
C                                                                       34416540
C         THIS SUBROUTINE CALCULATES THE SECTOR CONCENTRATION FROM      34416550
C          POINT SOURCES.                                               34416560
C                                                                       34416570
      PARAMETER (NPTS=200,NQLIM=100,NASE=50,NASN=50)                    34416580
      DIMENSION S(2)                                                    34416590
      COMMON /C1/ K,MX,MN,F(6,6,36),UBAR(6),U(6),RI,RJ,INC(4),DELR      34416600
      COMMON /C2/ UE(6),YD,YN,TMN,DINT,YCON,TA(4),IPG,XG,YG,IRD         34416610
      COMMON /C3/ IRUN,CA(2),CB(2),TK(36),AROS(2),PROS(2),TANG          34416620
      COMMON /C4/ DECAY(2),ICA(6),ICP(6),HL(6),HX(6),GB(2),NQ,IVER,IWR  34416630
      COMMON /C5/ Q(NQLIM,4),GA(2),IAD(4,5),IAS,TDA,TDB,TDC,IPU         34416640
      COMMON /PCOM/ PH(NPTS),PR(NPTS),PS(NPTS,4),PX(NPTS),PY(NPTS),     34416650
     *              WA(36),WB(36),PROSE(36,2),CV,IPS,RAT,PBAR(2),TOA,   34416660
     *              VS1(NPTS),T1(NPTS),D1(NPTS),FRN(NPTS),BFLUX(NPTS)   34416670
      COMMON /SET/ N1636,DELTA,TTAN,NP50,NPDH,NSTDW,NGRAD,KLOW,KHIGH,   34416680
     *             PPAR(2,6),APAR(2,6),WHA(6),FAC,RCEPTZ,KELVIN,NDEF    34416690
C                                                                       34416700
C         INITIALIZE POINT SOURCE COUNTER.                              34416710
C          IP LOOPS TO IPS (NUMBER OF POINT SOURCES)                    34416720
      IP=1                                                              34416730
C                                                                       34416740
C         FIND UPWIND (XP) AND CROSSWIND (YP) DISTANCES FROM RECEPTOR   34416750
C          TO SOURCE                                                    34416760
C                                                                       34416770
   10 VX=PX(IP)-RI                                                      34416780
      VY=PY(IP)-RJ                                                      34416790
      XP=(VY*WA(K)+VX*WB(K))*RAT*CV                                     34416800
      IF(XP.LE.0.) GO TO 180                                            34416810
      YP=ABS((VY*WB(K)-VX*WA(K))*RAT*CV)                                34416820
      TM=XP*TTAN                                                        34416830
C                                                                       34416840
C         IF SOURCE MAKES NO CONTRIBUTION TO RECEPTOR, SKIP TO NEXT     34416850
C                                                                       34416860
      IF(YP.GT.TM) GO TO 180                                            34416870
      IF(PH(IP).GE.50.) GO TO 20                                        34416880
      IF(NP50.LE.0) GO TO 20                                            34416890
      SZI=50.-PH(IP)                                                    34416900
      IF(SZI.GT.30.) SZI=30.                                            34416910
      GO TO 30                                                          34416920
   20 SZI=0.                                                            34416930
   30 Y=YD                                                              34416940
C                                                                       34416950
C         BEGIN LOOP OVER STABILITY CLASS                               34416960
C                                                                       34416970
      DO 170 IS=1,6                                                     34416980
C         IS: CONTROLS STABILITY CLASS                                  34416990
      IF(IS.EQ.5) Y=YN                                                  34417000
      IC=ICP(IS)                                                        34417010
      WZ=(PH(IP)*0.1)**UE(IS)                                           34417020
      IF(SZI.LE.0.) GO TO 40                                            34417030
      CALL VIRTX(KHIGH,NPDH,IC,0.0,SZI,XS)                              34417040
      GO TO 50                                                          34417050
   40 XS=0.                                                             34417060
   50 DIST=XP+XS                                                        34417070
C                                                                       34417080
C         BEGIN LOOP OVER WIND SPEED CLASS                              34417090
C                                                                       34417100
      DO 160 IU=1,6                                                     34417110
C         IU: CONTOLS WIND SPEED CLASS                                  34417120
C          IF FREQUENCY IS ZERO, SKIP                                   34417130
      IF(F(IS,IU,K).LE.0.) GO TO 160                                    34417140
      WS=U(IU)*WZ                                                       34417150
      DO 60 JA=1,2                                                      34417160
         DF=WS*GA(JA)                                                   34417170
         IF (DF.NE.0.0) THEN                                            9240000
            DECAY(JA)=EXP(XP/DF)                                        92417180
         ELSE                                                           9240000
            DECAY(JA)=0.0                                               9240000
         ENDIF                                                          9240000
   60 CONTINUE                                                          9240000
C                                                                       34417190
C         IF PR(IP) IS LESS THAN OR EQUAL TO ZERO COMPUTE PLUME RISE    34417200
C          ACCORDING TO BRIGGS.                                         34417210
C                                                                       34417220
      IF(PR(IP).LE.0.) GO TO 70                                         34417230
C                                                                       34417240
C         HOLLANDS EQN.                                                 34417250
C                                                                       34417260
      DH=PR(IP)/WS                                                      34417270
C         CALCULATE PLUME RISE                                          34417280
      IK = IC                                                           34417290
      IF(IK.GT.4) IK = IK - 1                                           34417300
      DH=DH*(1.4-0.1*IK)                                                34417310
      HP = PH(IP)                                                       34417320
      DHM = DH                                                          34417330
C         CALCULATE STACK DOWNWASH EFFECTS                              34417340
C                                                                       34417350
      CALL STDW(NSTDW,VS1(IP),D1(IP),FRN(IP),WS,HP,DHM)                 34417360
      PHDH = HP + DHM                                                   34417370
      GO TO 120                                                         34417380
C                                                                       34417390
C         CALCULATE BRIGGS PLUME RISE  (1969, 1971, AND 1975)           34417400
C                                                                       34417410
   70 KST = IC                                                          34417420
C         CALCULATE PLUME RISE AND DISTANCE TO FINAL RISE.              34417430
      CALL PLRISE(VS1(IP),T1(IP),D1(IP),BFLUX(IP),TOA,WS,KST,DISTF,DH)  34417440
      HP = PH(IP)                                                       34417450
      DHM = DH                                                          34417460
C         CALCULATE STACK DOWNWASH EFFECTS                              34417470
      CALL STDW(NSTDW,VS1(IP),D1(IP),FRN(IP),WS,HP,DHM)                 34417480
      PHDH = HP + DHM                                                   34417490
C         CONSIDER GRADUAL PLUME RISE IF RECEPTOR DOWNWIND DISTANCE IS  34417500
C         LESS THAN THE DISTANCE TO FINAL RISE                          34417510
      IF (DIST .GE. DISTF) GO TO 120                                    34417520
C         CONSIDER GRADUAL PLUME RISE IF THE GRADUAL PLUME RISE OPTION  34417530
C         IS TURNED ON AND/OR THE BUOYANCY-INDUCED DISPERSION OPTION IS 34417540
C         TURNED ON                                                     34417550
      IF ((NGRAD .LE. 0) .AND. (NPDH .LE. 0)) GO TO 120                 34417560
C                                                                       34417570
C         CALCULATE GRADUAL PLUME RISE                                  34417580
C                                                                       34417590
      GDELH = (160. * BFLUX(IP)**0.333333 * DIST**0.666667)/WS          34417600
      IF (GDELH .LT. DHM) DHM = GDELH                                   34417610
C         MODIFY THE FINAL EFFECTIVE HEIGHT ONLY IF THE GRADUAL PLUME   34417620
C         RISE OPTION IS TURNED ON                                      34417630
      IF (NGRAD .GT. 0) PHDH = HP + DHM                                 34417640
C                                                                       34417650
  120 CONTINUE                                                          34417660
C                                                                       34417670
C   CHECK TO SEE IF PLUME IS ABOVE UNSTABLE OR NEUTRAL MIXING DEPTH     34417680
C                                                                       34417690
      IF(IC.LE.5) THEN                                                  34417700
      IF(PHDH.GT.HL(IS) ) GO TO 160                                     34417710
      END IF                                                            34417720
C                                                                       34417730
      CALL SIGMAZ(KHIGH,NPDH,IC,DIST,DHM,SZ)                            34417740
C                                                                       34417750
      HHH1=PHDH+RCEPTZ                                                  34417760
      HH21 = HHH1*HHH1                                                  34417770
      HHH2=PHDH-RCEPTZ                                                  34417780
      HH22 = HHH2*HHH2                                                  34417790
      PHDH=PHDH*PHDH                                                    34417800
C                                                                       34417810
C          FOR UNSTABLE AND NEUTRAL CONDITIONS (A - D2) SEE             34417820
C          IF THE VERTICAL DISPERSION PARAMETER IS GREATER THAN OR      34417830
C          EQUAL TO 0.8 X MIXING HEIGHT, COMPUTE CONCENTRATION BY A     34417840
C          BOX MODEL                                                    34417850
C                                                                       34417860
      IF(IC.LE.5) THEN                                                  34417870
      IF(SZ.GE.HX(IS)) GO TO 130                                        34417880
      END IF                                                            34417890
C                                                                       34417900
C         LID HAS NOT BEEN REACHED; COMPUTE CONCENTRATION BY GAUSSIAN   34417910
C          FORMULA.                                                     34417920
C                                                                       34417930
      B=-0.5*(PHDH/(SZ*SZ))                                             34417940
      IF(ABS(B).GT.60.) GO TO 160                                       34417950
      WW=WS*XP*SZ                                                       34417960
      S(1)=PS(IP,1)/WW                                                  34417970
      S(2)=PS(IP,2)/WW                                                  34417980
      B1 = -0.5*HH21/(SZ*SZ)                                            34417990
      B2 = -0.5*HH22/(SZ*SZ)                                            34418000
      WW = 0.5*(EXP(B1) + EXP(B2))                                      34418010
      S(1)=S(1)*WW                                                      34418020
      S(2)=S(2)*WW                                                      34418030
      GO TO 140                                                         34418040
C                                                                       34418050
C         LID HAS BEEN REACHED, COMPUTE CONCENTRATION BY A BOX MODEL.   34418060
C                                                                       34418070
  130 WW=WS*XP*HL(IS)                                                   34418080
      S(1)=PS(IP,3)/WW                                                  34418090
      S(2)=PS(IP,4)/WW                                                  34418100
C                                                                       34418110
C         STORE CONCENTRATION ACCORDING TO WIND DIRECTION SECTOR        34418120
C                                                                       34418130
  140 B=Y*YCON*F(IS,IU,K)                                               34418140
      DO 150 JB=1,2                                                     34418150
         IF (DECAY(JB).NE.0.0) THEN                                     9240000
            X=S(JB)*B/DECAY(JB)                                         92418160
            PROSE(K,JB)=PROSE(K,JB)+X                                   92418170
            PPAR(JB,IS) = PPAR(JB,IS) + X                               92418180
            PBAR(JB)=PBAR(JB)+X                                         92418190
         ENDIF                                                          9240000
  150 CONTINUE                                                          9240000
  160 CONTINUE                                                          34418200
  170 CONTINUE                                                          34418210
C                                                                       34418220
C         INCREMENT POINT SOURCE COUNTER                                34418230
C                                                                       34418240
  180 IP=IP+1                                                           34418250
C                                                                       34418260
C         LOOP UNTIL ALL POINT SOURCES EVALUATED                        34418270
C                                                                       34418280
      IF(IP.LE.IPS) GO TO 10                                            34418290
      RETURN                                                            34418300
      END                                                               34418310
C                                                                       34419960
C********************************************************************** 34419970
C                                                                       34419980
C
      SUBROUTINE SIGMAZ(KTYPE,KEY,INKST,X,DH,SZ)                        34419990
C                                                                       34420000
C                                                                       34420010
C         IN THIS SUBROUTINE WE COMPUTE THE VERTICAL DISPERSION USING   34420020
C          TWO BASIC FORMS.  THE BASIC FORMS USED TO COMPUTE SZ ARE AS  34420030
C          FOLLOWS:                                                     34420040
C                                                                       34420050
C          FORM ONE. (BRIGGS, RURAL AND URBAN)                          34420060
C             SZ = A*X/(1+B*X)**C                                       34420070
C                                                                       34420080
C          FORM TWO.  (BNL, KLUG, ST. LOUIS, PGCDM, AND PGSIG)          34420090
C             SZ = A*X**B                                               34420100
C                                                                       34420110
C         THE 7 VERTICAL DISPERSION SCHEMES ARE AS FOLLOWS:             34420120
C                                                                       34420130
C                 1    =  BRIGGS-RURAL, GIFFORD (1976)                  34420140
C                 2    =  BRIGGS-URBAN, GIFFORD (1976)                  34420150
C                 3    =  BNL, SINGER AND SMITH (1966)                  34420160
C                 4    =  KLUG, VOGT (1977)                             34420170
C                 5    =  ST. LOUIS, VOGT (1977)                        34420180
C                 6    =  PGCDM, BUSSE & ZIMMERMAN (1973)               34420190
C                 7    =  PGSIG, PASQUILL (1961) AND GIFFORD (1960)     34420200
C                                                                       34420210
C---------------------------------------------------------------------- 34420220
C                                                                       34420230
C         TO ADD A DISPERSION SCHEME THE FOLLOWING MODIFICATIONS MUST   34420240
C          BE MADE TO THE CDM-2.0 SOURCE CODE:                          34420250
C                                                                       34420260
C         IN SUBROUTINE SIGMAZ,                                         34420270
C           (1)  ADD STATEMENT LABEL TO COMPUTED GO TO                  34420280
C           (2)  INSERT THE FOLLOWING JUST BEFORE STATEMENT 190         34420290
C                  -  GO TO 190                                         34420300
C                  -  CODE FOR DISPERSION SCHEME                        34420310
C                                                                       34420320
C         IN BLOCK DATA,                                                34420330
C           (1)  MODIFY DIMENSIONS OF ARRAY DISP(8,__)                  34420340
C           (2)  ADD DISPERSION SCHEME DESCRIPTION TO DATA STATEMENT    34420350
C                OF ARRAY DISP.  MAKE SURE THE DESCRIPTION DOES NOT     34420360
C                EXCEED 32 CHARACTERS.                                  34420370
C                                                                       34420380
C         IN SUBROUTINE CLINT,                                          34420390
C           (1)  MODIFY ERROR CHECK OF KLOW AFTER RECORD TYPE 5 IS      34420400
C                READ                                                   34420410
C           (2)  MODIFY UPPER RANGE LIMIT OF FORMAT STATEMENT 70.       34420420
C           (3)  MODIFY ERROR CHECK OF KHIGH AFTER RECORD TYPE 6 IS     34420430
C                READ                                                   34420440
C           (4)  MODIFY UPPER RANGE LIMIT OF FORMAT STATEMENT 110.      34420450
C                                                                       34420460
C---------------------------------------------------------------------- 34420470
C                                                                       34420480
      DIMENSION A(7,5),B(7,5),C(7,5),G(7,6),XCAT(9,7),AA(10,7),BB(10,7) 34420490
      DATA A/ 0.2000, 0.1200, 0.0800, 0.0600, 0.0600, 0.0300, 0.0160,   34420500
     *        0.2400, 0.2400, 0.2000, 0.1400, 0.1400, 0.0800, 0.0800,   34420510
     *        0.4000, 0.4000, 0.3300, 0.2200, 0.2200, 0.0600, 0.0600,   34420520
     *        0.0170, 0.0720, 0.0760, 0.1400, 0.1400, 0.2170, 0.2620,   34420530
     *        0.0790, 0.0790, 0.1310, 0.9100, 0.9100, 1.9300, 1.9300/   34420540
      DATA B/ 0.0000, 0.0000, 0.0002, 0.0015, 0.0015, 0.0003, 0.0003,   34420550
     *        0.0010, 0.0010, 0.0000, 0.0003, 0.0003, 0.0015, 0.0015,   34420560
     *        0.9100, 0.9100, 0.8600, 0.7800, 0.7800, 0.7100, 0.7100,   34420570
     *        1.3800, 1.0210, 0.8790, 0.7270, 0.7270, 0.6100, 0.5000,   34420580
     *        1.2000, 1.2000, 1.0460, 0.7020, 0.7020, 0.4650, 0.4650/   34420590
      DATA C/ 1.0000, 1.0000, 0.5000, 0.5000, 0.5000, 1.0000,  1.0000 , 34420600
     *        -0.5000,-0.5000, 1.0000, 0.5000, 0.5000, 0.5000,  0.5000, 34420610
     *        21*0.0/                                                   34420620
      DATA G/2.539E-4,0.04936,0.1154,0.7368,0.7368,1.2969,1.5763,       34420630
     *       2.539E-4,0.04936,0.1014,0.2591,0.2591,0.2527,0.2017,       34420640
     *       0.0383,0.1393,0.1120,0.0856,0.0856,0.0818,0.0545,          34420650
     *       2.0886,1.1137,0.9109,0.5642,0.5642,0.4421,0.3606,          34420660
     *       2.0886,1.1137,0.9260,0.6869,0.6869,0.6341,0.6020,          34420670
     *       1.2812,0.9467,0.9100,0.8650,0.8650,0.8155,0.8124/          34420680
      DATA XCAT / 0.50, 0.40, 0.30, 0.25, 0.20, 0.15, 0.10, 0.00, 0.00, 34420690
     *            0.40, 0.20, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 34420700
     *            0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 34420710
     *            0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 34420720
     *           30.00,10.00, 3.00, 1.00, 0.30, 0.00, 0.00, 0.00, 0.00, 34420730
     *           40.00,20.00,10.00, 4.00, 2.00, 1.00, 0.30, 0.10, 0.00, 34420740
     *           60.00,30.00,15.00, 7.00, 3.00, 2.00, 1.00, 0.70, 0.20/ 34420750
      DATA AA /453.85,346.75,258.89,217.41,179.52,170.22,158.08,122.80, 34420760
     *           0.0,0.0,                                               34420770
     *         109.30,98.483,90.673,0.0,0.0,0.0,0.0,0.0,0.0,0.0,        34420780
     *         61.141,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,              34420790
     *         33.504,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,              34420800
     *         44.053,36.65,33.504,32.093,32.093,34.459,0.0,0.0,0.0,0.0,34420810
     *         47.618,35.42,26.97,24.703,22.534,21.628,21.628,23.331,   34420820
     *           24.26,0.0,                                             34420830
     *         34.219,27.074,22.651,17.836,16.187,14.823,13.953,13.953, 34420840
     *           14.457,15.209/                                         34420850
      DATA BB /2.1166,1.7283,1.4094,1.2644,1.1262,1.0932,1.0542,0.9447, 34420860
     *           0.0,0.0,                                               34420870
     *         1.0971,0.98332,0.93198,0.0,0.0,0.0,0.0,0.0,0.0,0.0,      34420880
     *         0.91465,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,             34420890
     *         0.8098,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,              34420900
     *         0.51179,0.56589,0.60486,0.64403,0.81066,0.86974,0.0,0.0, 34420910
     *           0.0,0.0,                                               34420920
     *         0.29592,0.37615,0.46713,0.50527,0.57154,0.63077,0.7566,  34420930
     *           0.81956,0.8366,0.0,                                    34420940
     *         0.21716,0.27436,0.32681,0.41507,0.4649,0.54503,0.63227,  34420950
     *           0.68465,0.78407,0.81558/                               34420960
C                                                                       34420970
      KST = INKST                                                       34420980
      IF(KST.GT.7) KST = 7                                              34420990
C                                                                       34421000
      GO TO(20,20,30,40,40,50,70),KTYPE                                 34421010
C                                                                       34421020
C         BRIGGS RURAL AND URBAN, GIFFORD (1976)                        34421030
C                                                                       34421040
   20 Z1 = A(KST,KTYPE)                                                 34421050
      Z2 = B(KST,KTYPE)                                                 34421060
      Z3 = C(KST,KTYPE)                                                 34421070
      SZ = Z1*X/( 1.0+Z2*X)**Z3                                         34421080
      GO TO 190                                                         34421090
C                                                                       34421100
C         BNL, SINGER AND SMITH (1966)                                  34421110
C                                                                       34421120
   30 Z1 = A(KST,KTYPE)                                                 34421130
      Z2 = B(KST,KTYPE)                                                 34421140
      SZ = Z1*X**Z2                                                     34421150
      IF(KST.LE.4) GO TO 190                                            34421160
      IF(SZ.GT.50.0) SZ = 50.0                                          34421170
      GO TO 190                                                         34421180
C                                                                       34421190
C         KLUG, VOGT (1977); ST. LOUIS, VOGT (1977)                     34421200
C                                                                       34421210
   40 Z1 = A(KST,KTYPE)                                                 34421220
      Z2 = B(KST,KTYPE)                                                 34421230
      SZ = Z1*X**Z2                                                     34421240
      GO TO 190                                                         34421250
C                                                                       34421260
C         PGCDM, BUSSE & ZIMMERMAN (1973)                               34421270
C                                                                       34421280
   50 IC = KST                                                          34421290
      IZ = 1                                                            34421300
      IF(X.GE.5000.0) GO TO 60                                          34421310
      IZ = 2                                                            34421320
      IF(X.GE.500.0) GO TO 60                                           34421330
      IZ = 3                                                            34421340
   60 IB = IZ + 3                                                       34421350
      SZ = G(IC,IZ)*X**G(IC,IB)                                         34421360
      GO TO 190                                                         34421370
C                                                                       34421380
C         PGSIG, PASQUILL (1961) AND GIFFORD (1960)                     34421390
C                                                                       34421400
   70 X = X/1000.                                                       34421410
C         ARRAYS ARE DESIGNED FOR DISTANCE IN KILOMETERS                34421420
      DO 80 ID = 1,9                                                    34421430
         IF (X .GE. XCAT(ID,KST)) GO TO 90                              34421440
   80 CONTINUE                                                          34421450
      ID = 10                                                           34421460
   90 SZ = AA(ID,KST) * X ** BB(ID,KST)                                 34421470
      IF (SZ .GT. 5000.) SZ = 5000.                                     34421480
      X = X * 1000.                                                     34421490
C         CONVERT BACK TO METERS                                        34421500
C                                                                       34421510
  190 IF(KEY.LE.0) GO TO 200                                            34421520
      SZ = SQRT( SZ*SZ + (DH*DH)/(3.5*3.5))                             34421530
  200 RETURN                                                            34421540
      END                                                               34421550
C                                                                       34419060
C********************************************************************** 34419070
C                                                                       34419080
C
      SUBROUTINE STDW(NSTDW,VS,D,FR,U,H,DELH)                           34419090
C                                                                       34419100
C                                                                       34419110
C       PARAMETER LIST:                                                 34419120
C         INPUT:  NSTDW - STACK DOWNWASH OPTION                         34419130
C                 VS    - STACK GAS EXIT VELOCITY (M/SEC)               34419140
C                 D     - STACK INSIDE DIAMETER (METERS)                34419150
C                 FR    - FROUDE NUMBER                                 34419160
C                 U     - WIND SPEED AT STACK HEIGHT (M/SEC)            34419170
C         I/O:    H     - MODIFIED PHYSICAL STACK HEIGHT (METERS)       34419180
C                 DELH  - MODIFIED PLUME RISE (METERS)                  34419190
C                                                                       34419200
C         CALLING ROUTINE:                                              34419210
C           POINT                                                       34419220
C                                                                       34419230
C         DESCRIPTION:                                                  34419240
C           THIS SUBROUTINE CALCULATES STACK DOWNWASH EFFECTS.          34419250
C           IF NSTDW < 0, THEN STACK DOWNWASH CALCULATED ACCORDING TO   34419260
C                         BJORKLUND AND BOWERS (1982).                  34419270
C           IF NSTDW = 0, THEN STACK DOWNWASH NOT CONSIDERED.           34419280
C           IF NSTDW > 0, THEN STACK DOWNWASH CALCULATED ACCORDING TO   34419290
C                         BRIGGS (1973).                                34419300
C                                                                       34419310
      IF (NSTDW) 100,999,200                                            34419320
C                                                                       34419330
C         CALCULATE STACK DOWNWASH ACCORDING TO BJORKLUND AND           34419340
C          BOWERS (1982)                                                34419350
C                                                                       34419360
  100 IF (FR .LT. 3.0) GO TO 110                                        34419370
         F = (3.*VS - 3.*U)/VS                                          34419380
         IF (F .GT. 1.0) F = 1.0                                        34419390
         IF (F .LT. 0.0) F = 0.0                                        34419400
         GO TO 120                                                      34419410
  110 CONTINUE                                                          34419420
         F = 1.0                                                        34419430
  120 CONTINUE                                                          34419440
      DELH = F * DELH                                                   34419450
      GO TO 999                                                         34419460
C                                                                       34419470
C         CALCULATE STACK DOWNWASH ACCORDING TO BRIGGS (1973)           34419480
C                                                                       34419490
  200 IF (VS/U .GE. 1.5) GO TO 210                                      34419500
         H = H + 2 * D * (VS/U - 1.5)                                   34419510
         IF (H .LT. 0.0) H = 0.0                                        34419520
  210 CONTINUE                                                          34419530
C                                                                       34419540
  999 RETURN                                                            34419550
      END                                                               34419560
C                                                                       34419570
C********************************************************************** 34419580
C                                                                       34419590
C
      SUBROUTINE VIRTX(KTYPE,KEY,KST,DH,GSZ,EX)                         34419600
C                                                                       34419610
C                                                                       34419620
C         THIS SUBROUTINE COMPUTES THE VIRTUAL DISTANCE,                34419630
C          IN METERS, USING MUBROUTINE SIGMAZ.                          34419640
C          THE ROUTINE IS BASICALLY A NEWTON RELAXATION SCHEME          34419650
C                                                                       34419660
      XMAX = 100.0*1000.0                                               34419670
      IF(KTYPE.NE.4) GO TO 10                                           34419680
      IF(KST.LE.4) GO TO 10                                             34419690
      IF(GSZ.LT.50.0) GO TO 10                                          34419700
      GO TO 70                                                          34419710
   10 CONTINUE                                                          34419720
      X = 1.0                                                           34419730
   20 CALL SIGMAZ(KTYPE,KEY,KST,X,DH,SZ)                                34419740
      IF(SZ.GT.GSZ) GO TO 30                                            34419750
      IF(X.GT.XMAX) GO TO 30                                            34419760
      X = 2.0*X                                                         34419770
      GO TO 20                                                          34419780
   30 IF(X.LE.1.0) GO TO 70                                             34419790
      IF(X.GE.XMAX.AND.SZ.LT.GSZ) GO TO 60                              34419800
      X = 0.5*X                                                         34419810
      STEP = 0.25*X                                                     34419820
   40 CALL SIGMAZ(KTYPE,KEY,KST,X,DH,SZ)                                34419830
      IF(SZ.GT.GSZ) GO TO 50                                            34419840
      X = X + STEP                                                      34419850
      GO TO 40                                                          34419860
   50 IF(STEP.LT.0.40) GO TO 70                                         34419870
      X = X - STEP                                                      34419880
      STEP = 0.25*STEP                                                  34419890
      GO TO 40                                                          34419900
   60 EX = XMAX                                                         34419910
      GO TO 80                                                          34419920
   70 EX = X                                                            34419930
   80 RETURN                                                            34419940
      END                                                               34419950
